package com.netpotlet.cove.application;

import java.util.Stack;

import javax.faces.component.UIComponent;
import javax.faces.component.UIViewRoot;

import com.netpotlet.xul.component.ButtonComponent;
import com.netpotlet.xul.component.CaptionComponent;
import com.netpotlet.xul.component.ColumnComponent;
import com.netpotlet.xul.component.ColumnsComponent;
import com.netpotlet.xul.component.CoveComponent;
import com.netpotlet.xul.component.GridComponent;
import com.netpotlet.xul.component.GroupboxComponent;
import com.netpotlet.xul.component.LabelComponent;
import com.netpotlet.xul.component.RowComponent;
import com.netpotlet.xul.component.RowsComponent;
import com.netpotlet.xul.component.SpacerComponent;
import com.netpotlet.xul.component.TextboxComponent;
import com.netpotlet.xul.component.ScriptComponent;
import com.netpotlet.xul.component.WindowComponent;
import com.netpotlet.xul.element.RVisitorBase;
import com.netpotlet.xul.element.XulWindow;
import com.netpotlet.xul.element.XulGroupbox;
import com.netpotlet.xul.element.XulCaption;
import com.netpotlet.xul.element.XulGrid;
import com.netpotlet.xul.element.XulColumns;
import com.netpotlet.xul.element.XulColumn;
import com.netpotlet.xul.element.XulRows;
import com.netpotlet.xul.element.XulRow;
import com.netpotlet.xul.element.XulButton;
import com.netpotlet.xul.element.XulSpacer;
import com.netpotlet.xul.element.XulTextbox;
import com.netpotlet.xul.element.XulScript;
import com.netpotlet.xul.element.XulLabel;

public class XulVisitor extends RVisitorBase {
    private Stack stack = new Stack();
    private UIComponent root = null;

    public UIViewRoot getUIViewRoot() {
        if (root instanceof UIViewRoot) {
            return (UIViewRoot) root;
        }
        return null;
    }

    public boolean enter(XulCaption visitable) {
        CaptionComponent caption = new CaptionComponent(visitable);
        caption.setRendererType("XulCaption");
        createChain(caption);
        stack.push(caption);
        return (true);
    }

    public void leave(XulCaption visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulColumn visitable) {
        ColumnComponent column = new ColumnComponent(visitable);
        column.setRendererType("XulColumn");
        createChain(column);
        stack.push(column);
        return (true);
    }

    public void leave(XulColumn visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulColumns visitable) {
        ColumnsComponent columns = new ColumnsComponent(visitable);
        columns.setRendererType("XulColumns");
        createChain(columns);
        stack.push(columns);
        return (true);
    }

    public void leave(XulColumns visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulButton visitable) {
        ButtonComponent button = new ButtonComponent(visitable);
        button.setRendererType("XulButton");
        createChain(button);
        stack.push(button);
        return (true);
    }

    public void leave(XulButton visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulSpacer visitable) {
        SpacerComponent spacer = new SpacerComponent(visitable);
        spacer.setRendererType("XulSpacer");
        createChain(spacer);
        stack.push(spacer);
        return (true);
    }

    public void leave(XulSpacer visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulRow visitable) {
        RowComponent row = new RowComponent(visitable);
        row.setRendererType("XulRow");
        createChain(row);
        stack.push(row);
        return (true);
    }

    public void leave(XulRow visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulRows visitable) {
        RowsComponent rows = new RowsComponent(visitable);
        rows.setRendererType("XulRows");
        createChain(rows);
        stack.push(rows);
        return (true);
    }

    public void leave(XulRows visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulGrid visitable) {
        GridComponent grid = new GridComponent(visitable);
        grid.setRendererType("XulGrid");
        createChain(grid);
        stack.push(grid);
        return (true);
    }

    public void leave(XulGrid visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulGroupbox visitable) {
        GroupboxComponent groupbox = new GroupboxComponent(visitable);
        groupbox.setRendererType("XulGroupbox");
        createChain(groupbox);
        stack.push(groupbox);
        return (true);
    }

    public void leave(XulGroupbox visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulLabel visitable) {
        LabelComponent label = new LabelComponent(visitable);
        label.setRendererType("XulLabel");
        createChain(label);
        stack.push(label);
        return (true);
    }

    public void leave(XulLabel visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulTextbox visitable) {
        TextboxComponent textbox = new TextboxComponent(visitable);
        textbox.setRendererType("XulTextbox");
        createChain(textbox);
        stack.push(textbox);
        return (true);
    }

    public void leave(XulTextbox visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulScript visitable) {
        ScriptComponent script = new ScriptComponent(visitable);
        script.setRendererType("XulScript");
        createChain(script);
        stack.push(script);
        return (true);
    }

    public void leave(XulScript visitable) {
        root = (UIComponent) stack.pop();
    }

    public boolean enter(XulWindow visitable) {
        WindowComponent window = new WindowComponent(visitable);
        window.setRendererType("XulWindow");
        stack.push(window);
        return (true);
    }

    public void leave(XulWindow visitable) {
        root = (UIComponent) stack.pop();
    }

    private void createChain(UIComponent component) {
        if (!stack.empty()) {
            UIComponent parent = (UIComponent) stack.peek();
            if (parent instanceof CoveComponent) {
                CoveComponent coveComponent = (CoveComponent) parent;
                coveComponent.addChild(component);
            }
            component.setParent(parent);
        }
    }
}
