package com.netpotlet.cove.el;

import java.util.Map;
import javax.faces.context.ExternalContext;

public class CoveElImplicitObjects {
    private static CoveElImplicitObjects objs = null;
    private Map mPage;
    private Map mRequest;
    private Map mSession;
    private Map mApplication;
    private Map mParam;
    private Map mParams;
    private Map mHeader;
    private Map mHeaders;
    private Map mInitParams;
    private Map mCookie;

    private CoveElImplicitObjects(ExternalContext eContext) {
        mPage = null;
        mRequest = eContext.getRequestMap();
        mSession = eContext.getSessionMap();
        mApplication = eContext.getApplicationMap();
        mParam = eContext.getRequestParameterMap();
        mParams = eContext.getRequestParameterValuesMap();
        mHeader = eContext.getRequestHeaderMap();
        mHeaders = eContext.getRequestHeaderValuesMap();
        mInitParams = eContext.getInitParameterMap();
        mCookie = eContext.getRequestCookieMap();
    }

    public static CoveElImplicitObjects getImplicitObjects(ExternalContext eContext) {
        if (objs == null) {
            objs = new CoveElImplicitObjects(eContext);
        }
        return objs;
    }

    public Map getPageScopeMap() {
        return mPage;
    }

    public Map getRequestScopeMap() {
        return mRequest;
    }

    public Map getSessionScopeMap() {
        return mSession;
    }

    public Map getApplicationScopeMap() {
        return mApplication;
    }

    public Map getParamMap() {
        return mParam;
    }

    public Map getParamsMap() {
        return mParams;
    }

    public Map getHeaderMap() {
        return mHeader;
    }

    public Map getHeadersMap() {
        return mHeaders;
    }

    public Map getInitParamMap() {
        return mInitParams;
    }

    public Map getCookieMap() {
        return mCookie;
    }
}
