package com.netpotlet.cove.el;

import java.io.StringReader;
import java.lang.reflect.InvocationTargetException;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;

import org.apache.commons.el.ComplexValue;
import org.apache.commons.el.ExpressionString;
import org.apache.commons.el.FunctionInvocation;
import org.apache.commons.el.IntegerLiteral;
import org.apache.commons.el.parser.ELParser;
import org.apache.commons.el.parser.ParseException;

public class CoveElResolver {
    private static CoveElResolver resolver = null;
    private CoveElEvaluator evaluator;

    private CoveElResolver() {
        evaluator = new CoveElEvaluator(new CoveVariableResolver());
    }

    public static CoveElResolver getResolver() {
        if (resolver == null) {
            resolver = new CoveElResolver();
        }
        return resolver;
    }

    public synchronized String resolveExpression(String mixed)
        throws ParseException {
        if (mixed == null)
            return null;
        StringReader reader = new StringReader(mixed);
        ELParser elParser = new ELParser(reader);
        Object obj = elParser.ExpressionString();
        String resolvedString;
        try {
            resolvedString =
                evaluator.evaluate(FacesContext.getCurrentInstance(), obj);
            return resolvedString;
        } catch (EvaluationException e) {
            throw new ParseException(e.getMessage());
        } catch (IllegalArgumentException e) {
            throw new ParseException(e.getMessage());
        } catch (NoSuchMethodException e) {
            throw new ParseException(e.getMessage());
        } catch (IllegalAccessException e) {
            throw new ParseException(e.getMessage());
        } catch (InvocationTargetException e) {
            throw new ParseException(e.getMessage());
        }
    }

    private String getValueRef(String mixed) throws ParseException {
        StringReader reader = new StringReader(mixed);
        ELParser elParser = new ELParser(reader);
        Object obj = elParser.ExpressionString();
        String valueRef = null;
        if (obj instanceof ExpressionString) {
            Object[] objects = ((ExpressionString) obj).getElements();
            for (int j = 0; j < objects.length; j++) {
                if (objects[j] instanceof ComplexValue) {
                    valueRef =
                        ((ComplexValue) objects[j]).getExpressionString();
                }
            }
        } else if (obj instanceof ComplexValue) {
            valueRef = ((ComplexValue) obj).getExpressionString();
        } else if (obj instanceof IntegerLiteral) {
            valueRef = ((IntegerLiteral) obj).getExpressionString();
        } else if (obj instanceof FunctionInvocation) {
            valueRef = ((FunctionInvocation) obj).getExpressionString();
        }
        return valueRef;
    }
}
