package com.netpotlet.cove.el;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.el.VariableResolver;

public class CoveVariableResolver extends VariableResolver {

    public Object resolveVariable(FacesContext fContext, String pName) {
        ExternalContext context = fContext.getExternalContext();
        if ("pageContext".equals(pName)) {
            return context;
        } else if ("pageScope".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getPageScopeMap();
        } else if ("requestScope".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getRequestScopeMap();
        } else if ("sessionScope".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getSessionScopeMap();
        } else if ("applicationScope".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getApplicationScopeMap();
        } else if ("param".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getParamMap();
        } else if ("paramValues".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getParamsMap();
        } else if ("header".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getHeaderMap();
        } else if ("headerValues".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getHeadersMap();
        } else if ("initParam".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getInitParamMap();
        } else if ("cookie".equals(pName)) {
            return CoveElImplicitObjects
                .getImplicitObjects(context)
                .getCookieMap();
        }
        return null;
    }
}
