package com.netpotlet.xul.component;

import javax.faces.FactoryFinder;
import javax.faces.application.Application;
import javax.faces.application.ApplicationFactory;
import javax.faces.component.UIComponent;
import javax.faces.component.UICommand;
import javax.faces.el.MethodBinding;
import javax.faces.event.ActionEvent;
import javax.faces.webapp.UIComponentTag;

import com.netpotlet.cove.el.ConstantMethodBinding;
import com.netpotlet.xul.element.IXulButtonChoice;
import com.netpotlet.xul.element.XulButton;
import com.netpotlet.xul.element.XulConfig;

public class ButtonComponent extends UICommand implements CoveComponent {
    public XulButton xulButton;

    public ButtonComponent(XulButton button) {
        super();
        xulButton = button;
        setId(button.getId());
        setup(button.getContent());
    }

    public void addChild(UIComponent component) {
        getChildren().add(component);
    }

    public String getFamily() {
        return "Button";
    }

    private void setup(IXulButtonChoice[] choice) {
        for (int i=0; i<choice.length; i++) {
            if (choice[i] instanceof XulConfig) {
                XulConfig xulConfig = (XulConfig)choice[i];
                ApplicationFactory aFactory = 
                    (ApplicationFactory) FactoryFinder.getFactory(FactoryFinder.APPLICATION_FACTORY);
                Application application = aFactory.getApplication();
                String action = xulConfig.getActionAsString();
                if ((action != null) && (!"".equals(action))) {
                    MethodBinding methodBinding;
                    if (UIComponentTag.isValueReference(action)) {
                        Class[] args = {ActionEvent.class};
                        methodBinding = 
                            application.createMethodBinding(action, args);
                    } else {
                        methodBinding = 
                            new ConstantMethodBinding(action);
                    }
                    super.setAction(methodBinding);
                } 
                String actionListener = xulConfig.getActionListenerAsString();
                if ((actionListener != null) && (!"".equals(actionListener))) {
                    Class[] args = {ActionEvent.class};
                    MethodBinding methodBinding = 
                        application.createMethodBinding(actionListener, args);
                    super.setActionListener(methodBinding);
                }
            }
        }
    }
}
