/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

/**
 * @version xul-jsf.rng 1.0 (Sat Sep 25 09:38:17 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public interface IRVisitor {
    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulConfig visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulConfig visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenuitem visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenuitem visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenu visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenu visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenuseparator visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenuseparator visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreecell visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreecell visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreerow visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreerow visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreeitem visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreeitem visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreechildren visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreechildren visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulContent visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulContent visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMember visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMember visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTriple visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTriple visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulConditions visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulConditions visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBinding visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBinding visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBindings visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBindings visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulAction visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulAction visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTextbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTextbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCommand visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCommand visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCommandset visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCommandset visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulLabel visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulLabel visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulObserves visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulObserves visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListheader visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListheader visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListhead visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListhead visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListcol visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListcol visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListcols visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListcols visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListcell visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListcell visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListitem visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListitem visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRadio visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRadio visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCheckbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCheckbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreecol visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreecol visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulGrippy visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulGrippy visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSplitter visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSplitter visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreecols visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreecols visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTree visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTree visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTab visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTab visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTabs visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTabs visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulImage visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulImage visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulDescription visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulDescription visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulScript visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulScript visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenubar visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenubar visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBroadcaster visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBroadcaster visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBroadcasterset visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBroadcasterset visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulIframe visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulIframe visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulKey visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulKey visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulKeyset visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulKeyset visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulToolbarbutton visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulToolbarbutton visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulToolbarseparator visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulToolbarseparator visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulToolbar visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulToolbar visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulToolbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulToolbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSeparator visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSeparator visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSpacer visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSpacer visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenulist visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenulist visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulPopup visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulPopup visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTooltip visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTooltip visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulPopupset visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulPopupset visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRadiogroup visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRadiogroup visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulHbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulHbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulStack visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulStack visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulVbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulVbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulColumn visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulColumn visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulColumns visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulColumns visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRow visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRow visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRows visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRows visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulGrid visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulGrid visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulDeck visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulDeck visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCaption visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCaption visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulGroupbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulGroupbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTabpanel visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTabpanel visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTabpanels visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTabpanels visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTabbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTabbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulArrowscrollbox visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulArrowscrollbox visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRule visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRule visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTemplate visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTemplate visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenupopup visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenupopup visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulButton visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulButton visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulWindow visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulWindow visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRuleModel visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRuleModel visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreeChoice visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreeChoice visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulArrowscrollboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulArrowscrollboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBoxesClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBoxesClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBroadcastersetClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBroadcastersetClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulButtonClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulButtonClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCardsClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCardsClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCheckboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCheckboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulCommandClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulCommandClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulDescriptionClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulDescriptionClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulGridClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulGridClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulIframeClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulIframeClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulImageClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulImageClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulKeysetClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulKeysetClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulLabelClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulLabelClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulListboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulListboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulMenulistClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulMenulistClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulPopupsetClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulPopupsetClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulRadiogroupClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulRadiogroupClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulScriptClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulScriptClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSeparatorClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSeparatorClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSpacerClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSpacerClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulSplitterClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulSplitterClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTabboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTabboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTemplateClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTemplateClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTextboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTextboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulToolboxClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulToolboxClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulTreeClass visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulTreeClass visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(XulBlockModel visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(XulBlockModel visitable);
}
