/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * <b>IXulCommandClassChoice</b> is generated from xul-jsf.rng by Relaxer.
 * Concrete classes of the interface are XulCommandset and XulCommand.
 *
 * @version xul-jsf.rng (Sat Sep 25 09:38:08 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public interface IXulCommandClassChoice extends IRVisitable, IRNode {
    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    void makeElement(Node parent);

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    void makeTextElement(StringBuffer buffer);

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    void makeTextElement(Writer buffer) throws IOException;

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    void makeTextElement(PrintWriter buffer);

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    void makeTextAttribute(StringBuffer buffer);

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    void makeTextAttribute(Writer buffer) throws IOException;

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    void makeTextAttribute(PrintWriter buffer);

    /**
     * @param doc
     */
    void setup(Document doc);

    /**
     * @param element
     */
    void setup(Element element);

    /**
     * @param stack
     */
    void setup(RStack stack);

    /**
     * @return Object
     */
    Object clone();

    /**
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(File file) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(String uri) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(URL url) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * @exception ParserConfigurationException
     * @return Document
     */
    Document makeDocument() throws ParserConfigurationException;

    /**
     * @return RNSContext
     */
    RNSContext rGetRNSContext();

    /**
     * @param rNSContext
     */
    void rSetRNSContext(RNSContext rNSContext);

    /**
     * @return String
     */
    String getAlign();

    /**
     * @param align
     */
    void setAlign(String align);

    /**
     * @return boolean
     */
    boolean getAllowevents();

    /**
     * @param allowevents
     * @return boolean
     */
    boolean getAllowevents(boolean allowevents);

    /**
     * @return Boolean
     */
    Boolean getAlloweventsAsBoolean();

    /**
     * @return boolean
     */
    boolean checkAllowevents();

    /**
     * @param allowevents
     */
    void setAllowevents(boolean allowevents);

    /**
     * @param allowevents
     */
    void setAllowevents(Boolean allowevents);

    /**
     * @return boolean
     */
    boolean getAllownegativeassertions();

    /**
     * @param allownegativeassertions
     * @return boolean
     */
    boolean getAllownegativeassertions(boolean allownegativeassertions);

    /**
     * @return Boolean
     */
    Boolean getAllownegativeassertionsAsBoolean();

    /**
     * @return boolean
     */
    boolean checkAllownegativeassertions();

    /**
     * @param allownegativeassertions
     */
    void setAllownegativeassertions(boolean allownegativeassertions);

    /**
     * @param allownegativeassertions
     */
    void setAllownegativeassertions(Boolean allownegativeassertions);

    /**
     * @return String
     */
    String getClassValue();

    /**
     * @param classValue
     */
    void setClassValue(String classValue);

    /**
     * @return boolean
     */
    boolean getCoalesceduplicatearcs();

    /**
     * @param coalesceduplicatearcs
     * @return boolean
     */
    boolean getCoalesceduplicatearcs(boolean coalesceduplicatearcs);

    /**
     * @return Boolean
     */
    Boolean getCoalesceduplicatearcsAsBoolean();

    /**
     * @return boolean
     */
    boolean checkCoalesceduplicatearcs();

    /**
     * @param coalesceduplicatearcs
     */
    void setCoalesceduplicatearcs(boolean coalesceduplicatearcs);

    /**
     * @param coalesceduplicatearcs
     */
    void setCoalesceduplicatearcs(Boolean coalesceduplicatearcs);

    /**
     * @return boolean
     */
    boolean getCollapsed();

    /**
     * @param collapsed
     * @return boolean
     */
    boolean getCollapsed(boolean collapsed);

    /**
     * @return Boolean
     */
    Boolean getCollapsedAsBoolean();

    /**
     * @return boolean
     */
    boolean checkCollapsed();

    /**
     * @param collapsed
     */
    void setCollapsed(boolean collapsed);

    /**
     * @param collapsed
     */
    void setCollapsed(Boolean collapsed);

    /**
     * @return String
     */
    String getContainer();

    /**
     * @param container
     */
    void setContainer(String container);

    /**
     * @return String
     */
    String getContainment();

    /**
     * @param containment
     */
    void setContainment(String containment);

    /**
     * @return String
     */
    String getContext();

    /**
     * @param context
     */
    void setContext(String context);

    /**
     * @return String
     */
    String getContextmenu();

    /**
     * @param contextmenu
     */
    void setContextmenu(String contextmenu);

    /**
     * @return String
     */
    String getDatasources();

    /**
     * @param datasources
     */
    void setDatasources(String datasources);

    /**
     * @return boolean
     */
    boolean getDebug();

    /**
     * @param debug
     * @return boolean
     */
    boolean getDebug(boolean debug);

    /**
     * @return Boolean
     */
    Boolean getDebugAsBoolean();

    /**
     * @return boolean
     */
    boolean checkDebug();

    /**
     * @param debug
     */
    void setDebug(boolean debug);

    /**
     * @param debug
     */
    void setDebug(Boolean debug);

    /**
     * @return String
     */
    String getDir();

    /**
     * @param dir
     */
    void setDir(String dir);

    /**
     * @return boolean
     */
    boolean getEmpty();

    /**
     * @param empty
     * @return boolean
     */
    boolean getEmpty(boolean empty);

    /**
     * @return Boolean
     */
    Boolean getEmptyAsBoolean();

    /**
     * @return boolean
     */
    boolean checkEmpty();

    /**
     * @param empty
     */
    void setEmpty(boolean empty);

    /**
     * @param empty
     */
    void setEmpty(Boolean empty);

    /**
     * @return String
     */
    String getEqualsize();

    /**
     * @param equalsize
     */
    void setEqualsize(String equalsize);

    /**
     * @return String
     */
    String getFlags();

    /**
     * @param flags
     */
    void setFlags(String flags);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getFlex();

    /**
     * @param flex
     */
    void setFlex(java.math.BigInteger flex);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getHeight();

    /**
     * @param height
     */
    void setHeight(java.math.BigInteger height);

    /**
     * @return boolean
     */
    boolean getHidden();

    /**
     * @param hidden
     * @return boolean
     */
    boolean getHidden(boolean hidden);

    /**
     * @return Boolean
     */
    Boolean getHiddenAsBoolean();

    /**
     * @return boolean
     */
    boolean checkHidden();

    /**
     * @param hidden
     */
    void setHidden(boolean hidden);

    /**
     * @param hidden
     */
    void setHidden(Boolean hidden);

    /**
     * @return String
     */
    String getId();

    /**
     * @param id
     */
    void setId(String id);

    /**
     * @return String
     */
    String getInsertafter();

    /**
     * @param insertafter
     */
    void setInsertafter(String insertafter);

    /**
     * @return String
     */
    String getInsertbefore();

    /**
     * @param insertbefore
     */
    void setInsertbefore(String insertbefore);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getLeft();

    /**
     * @param left
     */
    void setLeft(java.math.BigInteger left);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getMaxheight();

    /**
     * @param maxheight
     */
    void setMaxheight(java.math.BigInteger maxheight);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getMaxwidth();

    /**
     * @param maxwidth
     */
    void setMaxwidth(java.math.BigInteger maxwidth);

    /**
     * @return String
     */
    String getMenu();

    /**
     * @param menu
     */
    void setMenu(String menu);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getMinheight();

    /**
     * @param minheight
     */
    void setMinheight(java.math.BigInteger minheight);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getMinwidth();

    /**
     * @param minwidth
     */
    void setMinwidth(java.math.BigInteger minwidth);

    /**
     * @return String
     */
    String getObserves();

    /**
     * @param observes
     */
    void setObserves(String observes);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getOrdinal();

    /**
     * @param ordinal
     */
    void setOrdinal(java.math.BigInteger ordinal);

    /**
     * @return String
     */
    String getOrient();

    /**
     * @param orient
     */
    void setOrient(String orient);

    /**
     * @return String
     */
    String getPack();

    /**
     * @param pack
     */
    void setPack(String pack);

    /**
     * @return String
     */
    String getPersist();

    /**
     * @param persist
     */
    void setPersist(String persist);

    /**
     * @return String
     */
    String getPopup();

    /**
     * @param popup
     */
    void setPopup(String popup);

    /**
     * @return String
     */
    String getPosition();

    /**
     * @param position
     */
    void setPosition(String position);

    /**
     * @return String
     */
    String getRef();

    /**
     * @param ref
     */
    void setRef(String ref);

    /**
     * @return String
     */
    String getRemoveelement();

    /**
     * @param removeelement
     */
    void setRemoveelement(String removeelement);

    /**
     * @return String
     */
    String getSortDirection();

    /**
     * @param sortDirection
     */
    void setSortDirection(String sortDirection);

    /**
     * @return String
     */
    String getSortResource();

    /**
     * @param sortResource
     */
    void setSortResource(String sortResource);

    /**
     * @return String
     */
    String getSortResource2();

    /**
     * @param sortResource2
     */
    void setSortResource2(String sortResource2);

    /**
     * @return String
     */
    String getStatustext();

    /**
     * @param statustext
     */
    void setStatustext(String statustext);

    /**
     * @return String
     */
    String getStyle();

    /**
     * @param style
     */
    void setStyle(String style);

    /**
     * @return String
     */
    String getTemplate();

    /**
     * @param template
     */
    void setTemplate(String template);

    /**
     * @return String
     */
    String getTooltip();

    /**
     * @param tooltip
     */
    void setTooltip(String tooltip);

    /**
     * @return String
     */
    String getTooltiptext();

    /**
     * @param tooltiptext
     */
    void setTooltiptext(String tooltiptext);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getTop();

    /**
     * @param top
     */
    void setTop(java.math.BigInteger top);

    /**
     * @return String
     */
    String getUri();

    /**
     * @param uri
     */
    void setUri(String uri);

    /**
     * @return java.math.BigInteger
     */
    java.math.BigInteger getWidth();

    /**
     * @param width
     */
    void setWidth(java.math.BigInteger width);

    /**
     * @return String
     */
    String getOncommand();

    /**
     * @param oncommand
     */
    void setOncommand(String oncommand);

    /**
     * @return String
     */
    String makeTextDocument();

    /**
     * @return String
     */
    String getAlignAsString();

    /**
     * @return String
     */
    String getAlloweventsAsString();

    /**
     * @return String
     */
    String getAllownegativeassertionsAsString();

    /**
     * @return String
     */
    String getClassValueAsString();

    /**
     * @return String
     */
    String getCoalesceduplicatearcsAsString();

    /**
     * @return String
     */
    String getCollapsedAsString();

    /**
     * @return String
     */
    String getContainerAsString();

    /**
     * @return String
     */
    String getContainmentAsString();

    /**
     * @return String
     */
    String getContextAsString();

    /**
     * @return String
     */
    String getContextmenuAsString();

    /**
     * @return String
     */
    String getDatasourcesAsString();

    /**
     * @return String
     */
    String getDebugAsString();

    /**
     * @return String
     */
    String getDirAsString();

    /**
     * @return String
     */
    String getEmptyAsString();

    /**
     * @return String
     */
    String getEqualsizeAsString();

    /**
     * @return String
     */
    String getFlagsAsString();

    /**
     * @return String
     */
    String getFlexAsString();

    /**
     * @return String
     */
    String getHeightAsString();

    /**
     * @return String
     */
    String getHiddenAsString();

    /**
     * @return String
     */
    String getIdAsString();

    /**
     * @return String
     */
    String getInsertafterAsString();

    /**
     * @return String
     */
    String getInsertbeforeAsString();

    /**
     * @return String
     */
    String getLeftAsString();

    /**
     * @return String
     */
    String getMaxheightAsString();

    /**
     * @return String
     */
    String getMaxwidthAsString();

    /**
     * @return String
     */
    String getMenuAsString();

    /**
     * @return String
     */
    String getMinheightAsString();

    /**
     * @return String
     */
    String getMinwidthAsString();

    /**
     * @return String
     */
    String getObservesAsString();

    /**
     * @return String
     */
    String getOrdinalAsString();

    /**
     * @return String
     */
    String getOrientAsString();

    /**
     * @return String
     */
    String getPackAsString();

    /**
     * @return String
     */
    String getPersistAsString();

    /**
     * @return String
     */
    String getPopupAsString();

    /**
     * @return String
     */
    String getPositionAsString();

    /**
     * @return String
     */
    String getRefAsString();

    /**
     * @return String
     */
    String getRemoveelementAsString();

    /**
     * @return String
     */
    String getSortDirectionAsString();

    /**
     * @return String
     */
    String getSortResourceAsString();

    /**
     * @return String
     */
    String getSortResource2AsString();

    /**
     * @return String
     */
    String getStatustextAsString();

    /**
     * @return String
     */
    String getStyleAsString();

    /**
     * @return String
     */
    String getTemplateAsString();

    /**
     * @return String
     */
    String getTooltipAsString();

    /**
     * @return String
     */
    String getTooltiptextAsString();

    /**
     * @return String
     */
    String getTopAsString();

    /**
     * @return String
     */
    String getUriAsString();

    /**
     * @return String
     */
    String getWidthAsString();

    /**
     * @return String
     */
    String getOncommandAsString();

    /**
     * @param string
     */
    void setAlignByString(String string);

    /**
     * @param string
     */
    void setAlloweventsByString(String string);

    /**
     * @param string
     */
    void setAllownegativeassertionsByString(String string);

    /**
     * @param string
     */
    void setClassValueByString(String string);

    /**
     * @param string
     */
    void setCoalesceduplicatearcsByString(String string);

    /**
     * @param string
     */
    void setCollapsedByString(String string);

    /**
     * @param string
     */
    void setContainerByString(String string);

    /**
     * @param string
     */
    void setContainmentByString(String string);

    /**
     * @param string
     */
    void setContextByString(String string);

    /**
     * @param string
     */
    void setContextmenuByString(String string);

    /**
     * @param string
     */
    void setDatasourcesByString(String string);

    /**
     * @param string
     */
    void setDebugByString(String string);

    /**
     * @param string
     */
    void setDirByString(String string);

    /**
     * @param string
     */
    void setEmptyByString(String string);

    /**
     * @param string
     */
    void setEqualsizeByString(String string);

    /**
     * @param string
     */
    void setFlagsByString(String string);

    /**
     * @param string
     */
    void setFlexByString(String string);

    /**
     * @param string
     */
    void setHeightByString(String string);

    /**
     * @param string
     */
    void setHiddenByString(String string);

    /**
     * @param string
     */
    void setIdByString(String string);

    /**
     * @param string
     */
    void setInsertafterByString(String string);

    /**
     * @param string
     */
    void setInsertbeforeByString(String string);

    /**
     * @param string
     */
    void setLeftByString(String string);

    /**
     * @param string
     */
    void setMaxheightByString(String string);

    /**
     * @param string
     */
    void setMaxwidthByString(String string);

    /**
     * @param string
     */
    void setMenuByString(String string);

    /**
     * @param string
     */
    void setMinheightByString(String string);

    /**
     * @param string
     */
    void setMinwidthByString(String string);

    /**
     * @param string
     */
    void setObservesByString(String string);

    /**
     * @param string
     */
    void setOrdinalByString(String string);

    /**
     * @param string
     */
    void setOrientByString(String string);

    /**
     * @param string
     */
    void setPackByString(String string);

    /**
     * @param string
     */
    void setPersistByString(String string);

    /**
     * @param string
     */
    void setPopupByString(String string);

    /**
     * @param string
     */
    void setPositionByString(String string);

    /**
     * @param string
     */
    void setRefByString(String string);

    /**
     * @param string
     */
    void setRemoveelementByString(String string);

    /**
     * @param string
     */
    void setSortDirectionByString(String string);

    /**
     * @param string
     */
    void setSortResourceByString(String string);

    /**
     * @param string
     */
    void setSortResource2ByString(String string);

    /**
     * @param string
     */
    void setStatustextByString(String string);

    /**
     * @param string
     */
    void setStyleByString(String string);

    /**
     * @param string
     */
    void setTemplateByString(String string);

    /**
     * @param string
     */
    void setTooltipByString(String string);

    /**
     * @param string
     */
    void setTooltiptextByString(String string);

    /**
     * @param string
     */
    void setTopByString(String string);

    /**
     * @param string
     */
    void setUriByString(String string);

    /**
     * @param string
     */
    void setWidthByString(String string);

    /**
     * @param string
     */
    void setOncommandByString(String string);

    /**
     * @return String
     */
    String toString();

    /**
     * @param name
     * @return String
     */
    String rGetPi(String name);

    /**
     * @return java.util.Map
     */
    java.util.Map rGetPiMap();
}
