/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>XulConfig</b> is generated from xul-jsf.rng by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <element name="config">
 *       <ref name="config.attlist"/>
 *     </element>-->
 * <!-- for javadoc -->
 * <pre> &lt;element name="config"&gt;
 *       &lt;ref name="config.attlist"/&gt;
 *     &lt;/element&gt;</pre>
 *
 * @version xul-jsf.rng (Sat Sep 25 09:37:58 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class XulConfig implements java.io.Serializable, Cloneable, IRNSContainer, IRVisitable, IRNode, IXulButtonChoice {
    private RNSContext rNSContext_ = new RNSContext(this, "urn:JavaServerFaces");
    private String action_;
    private String actionListener_;
    private String converter_;
    private String validator_;
    private String value_;
    private java.util.Map xmlPIMap_;
    private IRNode parentRNode_;

    /**
     * Creates a <code>XulConfig</code>.
     *
     */
    public XulConfig() {
    }

    /**
     * Creates a <code>XulConfig</code>.
     *
     * @param source
     */
    public XulConfig(XulConfig source) {
        setup(source);
    }

    /**
     * Creates a <code>XulConfig</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XulConfig(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XulConfig</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XulConfig(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XulConfig</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XulConfig(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>XulConfig</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>XulConfig</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>XulConfig</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>XulConfig</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>XulConfig</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>XulConfig</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulConfig(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>XulConfig</code> by the XulConfig <code>source</code>.
     *
     * @param source
     */
    public void setup(XulConfig source) {
        int size;
        action_ = source.action_;
        actionListener_ = source.actionListener_;
        converter_ = source.converter_;
        validator_ = source.validator_;
        value_ = source.value_;
    }

    /**
     * Initializes the <code>XulConfig</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XulConfig</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XulConfig</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rNSContext_.declareNamespace(element);
        action_ = URelaxer.getAttributePropertyAsString(element, "action");
        actionListener_ = URelaxer.getAttributePropertyAsString(element, "actionListener");
        converter_ = URelaxer.getAttributePropertyAsString(element, "converter");
        validator_ = URelaxer.getAttributePropertyAsString(element, "validator");
        value_ = URelaxer.getAttributePropertyAsString(element, "value");
        xmlPIMap_ = stack.getPIMap();
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new XulConfig((XulConfig)this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElementNS("urn:JavaServerFaces", "config");
        rNSContext_.setupNamespace(element);
        int size;
        if (this.action_ != null) {
            URelaxer.setAttributePropertyByString(element, "action", this.action_);
        }
        if (this.actionListener_ != null) {
            URelaxer.setAttributePropertyByString(element, "actionListener", this.actionListener_);
        }
        if (this.converter_ != null) {
            URelaxer.setAttributePropertyByString(element, "converter", this.converter_);
        }
        if (this.validator_ != null) {
            URelaxer.setAttributePropertyByString(element, "validator", this.validator_);
        }
        if (this.value_ != null) {
            URelaxer.setAttributePropertyByString(element, "value", this.value_);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>XulConfig</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>XulConfig</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulConfig</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulConfig</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulConfig</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulConfig</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the RNSContext property <b>RNSContext</b>.
     *
     * @return RNSContext
     */
    public RNSContext rGetRNSContext() {
        return (rNSContext_);
    }

    /**
     * Sets the RNSContext property <b>RNSContext</b>.
     *
     * @param rNSContext
     */
    public void rSetRNSContext(RNSContext rNSContext) {
        this.rNSContext_ = rNSContext;
    }

    /**
     * Gets the String property <b>action</b>.
     *
     * @return String
     */
    public String getAction() {
        return (action_);
    }

    /**
     * Sets the String property <b>action</b>.
     *
     * @param action
     */
    public void setAction(String action) {
        this.action_ = action;
    }

    /**
     * Gets the String property <b>actionListener</b>.
     *
     * @return String
     */
    public String getActionListener() {
        return (actionListener_);
    }

    /**
     * Sets the String property <b>actionListener</b>.
     *
     * @param actionListener
     */
    public void setActionListener(String actionListener) {
        this.actionListener_ = actionListener;
    }

    /**
     * Gets the String property <b>converter</b>.
     *
     * @return String
     */
    public String getConverter() {
        return (converter_);
    }

    /**
     * Sets the String property <b>converter</b>.
     *
     * @param converter
     */
    public void setConverter(String converter) {
        this.converter_ = converter;
    }

    /**
     * Gets the String property <b>validator</b>.
     *
     * @return String
     */
    public String getValidator() {
        return (validator_);
    }

    /**
     * Sets the String property <b>validator</b>.
     *
     * @param validator
     */
    public void setValidator(String validator) {
        this.validator_ = validator;
    }

    /**
     * Gets the String property <b>value</b>.
     *
     * @return String
     */
    public String getValue() {
        return (value_);
    }

    /**
     * Sets the String property <b>value</b>.
     *
     * @param value
     */
    public void setValue(String value) {
        this.value_ = value;
    }

    /**
     * Makes an XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("urn:JavaServerFaces");
        buffer.append("<");
        URelaxer.makeQName(prefix, "config", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (action_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "action", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getAction())));
            buffer.append("\"");
        }
        if (actionListener_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "actionListener", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getActionListener())));
            buffer.append("\"");
        }
        if (converter_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "converter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getConverter())));
            buffer.append("\"");
        }
        if (validator_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "validator", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getValidator())));
            buffer.append("\"");
        }
        if (value_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.append("\"");
        }
        buffer.append(">");
        buffer.append("</");
        URelaxer.makeQName(prefix, "config", buffer);
        buffer.append(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        String prefix = rNSContext_.getPrefixByUri("urn:JavaServerFaces");
        buffer.write("<");
        URelaxer.makeQName(prefix, "config", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (action_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "action", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getAction())));
            buffer.write("\"");
        }
        if (actionListener_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "actionListener", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getActionListener())));
            buffer.write("\"");
        }
        if (converter_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "converter", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getConverter())));
            buffer.write("\"");
        }
        if (validator_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "validator", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getValidator())));
            buffer.write("\"");
        }
        if (value_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.write("\"");
        }
        buffer.write(">");
        buffer.write("</");
        URelaxer.makeQName(prefix, "config", buffer);
        buffer.write(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("urn:JavaServerFaces");
        buffer.print("<");
        URelaxer.makeQName(prefix, "config", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (action_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "action", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getAction())));
            buffer.print("\"");
        }
        if (actionListener_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "actionListener", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getActionListener())));
            buffer.print("\"");
        }
        if (converter_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "converter", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getConverter())));
            buffer.print("\"");
        }
        if (validator_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "validator", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getValidator())));
            buffer.print("\"");
        }
        if (value_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.print("\"");
        }
        buffer.print(">");
        buffer.print("</");
        URelaxer.makeQName(prefix, "config", buffer);
        buffer.print(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getActionAsString() {
        return (URelaxer.getString(getAction()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getActionListenerAsString() {
        return (URelaxer.getString(getActionListener()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getConverterAsString() {
        return (URelaxer.getString(getConverter()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getValidatorAsString() {
        return (URelaxer.getString(getValidator()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getValueAsString() {
        return (URelaxer.getString(getValue()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setActionByString(String string) {
        setAction(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setActionListenerByString(String string) {
        setActionListener(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setConverterByString(String string) {
        setConverter(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setValidatorByString(String string) {
        setValidator(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setValueByString(String string) {
        setValue(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets PI by name.
     *
     * @param name
     * @return String
     */
    public String rGetPi(String name) {
        return ((String)xmlPIMap_.get(name));
    }

    /**
     * Gets PI map.
     *
     * @return java.util.Map
     */
    public java.util.Map rGetPiMap() {
        return (java.util.Collections.unmodifiableMap(xmlPIMap_));
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public void rSetParentRNode(IRNode parentRNode) {
        this.parentRNode_ = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XulConfig</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer2.isTargetElement(element, "urn:JavaServerFaces", "config")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulConfig</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulConfig</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
