/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>XulMenulist</b> is generated from xul-jsf.rng by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <element name="menulist">
 *       <ref name="core.attlist"/>
 *       <ref name="disableautoselect.attrib"/>
 *       <ref name="disabled.attrib"/>
 *       <ref name="editable.attrib"/>
 *       <ref name="focused.attrib"/>
 *       <ref name="open.attrib"/>
 *       <ref name="src.attrib"/>
 *       <ref name="tabindex.attrib"/>
 *       <ref name="value.attrib"/>
 *       <ref name="menupopup"/>
 *     </element>-->
 * <!-- for javadoc -->
 * <pre> &lt;element name="menulist"&gt;
 *       &lt;ref name="core.attlist"/&gt;
 *       &lt;ref name="disableautoselect.attrib"/&gt;
 *       &lt;ref name="disabled.attrib"/&gt;
 *       &lt;ref name="editable.attrib"/&gt;
 *       &lt;ref name="focused.attrib"/&gt;
 *       &lt;ref name="open.attrib"/&gt;
 *       &lt;ref name="src.attrib"/&gt;
 *       &lt;ref name="tabindex.attrib"/&gt;
 *       &lt;ref name="value.attrib"/&gt;
 *       &lt;ref name="menupopup"/&gt;
 *     &lt;/element&gt;</pre>
 *
 * @version xul-jsf.rng (Sat Sep 25 09:38:07 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class XulMenulist implements java.io.Serializable, Cloneable, IRNSContainer, IRVisitable, IRNode, IXulHboxChoice, IXulRadiogroupChoice, IXulTooltipChoice, IXulStackChoice, IXulVboxChoice, IXulColumnChoice, IXulRowChoice, IXulBoxChoice, IXulDeckChoice, IXulCaptionChoice, IXulGroupboxChoice, IXulTabpanelChoice, IXulArrowscrollboxChoice, IXulMenulistClassChoice, IXulWindowChoice {
    public static final String CROP_START = "start";
    public static final String CROP_END = "end";
    public static final String CROP_CENTER = "center";
    public static final String CROP_NONE = "none";

    private RNSContext rNSContext_ = new RNSContext(this, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
    private String accesskey_;
    private String crop_;
    private String image_;
    private String label_;
    private Boolean disableautoselect_;
    private Boolean disabled_;
    private Boolean editable_;
    private Boolean focused_;
    private Boolean open_;
    private String src_;
    private java.math.BigInteger tabindex_;
    private String value_;
    private XulMenupopup menupopup_;
    private java.util.Map xmlPIMap_;
    private IRNode parentRNode_;

    /**
     * Creates a <code>XulMenulist</code>.
     *
     */
    public XulMenulist() {
    }

    /**
     * Creates a <code>XulMenulist</code>.
     *
     * @param source
     */
    public XulMenulist(XulMenulist source) {
        setup(source);
    }

    /**
     * Creates a <code>XulMenulist</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XulMenulist(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XulMenulist</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XulMenulist(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XulMenulist</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XulMenulist(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>XulMenulist</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>XulMenulist</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>XulMenulist</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>XulMenulist</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>XulMenulist</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>XulMenulist</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulMenulist(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>XulMenulist</code> by the XulMenulist <code>source</code>.
     *
     * @param source
     */
    public void setup(XulMenulist source) {
        int size;
        accesskey_ = source.accesskey_;
        crop_ = source.crop_;
        image_ = source.image_;
        label_ = source.label_;
        disableautoselect_ = source.disableautoselect_;
        disabled_ = source.disabled_;
        editable_ = source.editable_;
        focused_ = source.focused_;
        open_ = source.open_;
        src_ = source.src_;
        tabindex_ = source.tabindex_;
        value_ = source.value_;
        if (source.menupopup_ != null) {
            setMenupopup((XulMenupopup)source.getMenupopup().clone());
        }
    }

    /**
     * Initializes the <code>XulMenulist</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XulMenulist</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XulMenulist</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rNSContext_.declareNamespace(element);
        accesskey_ = URelaxer.getAttributePropertyAsString(element, "accesskey");
        crop_ = URelaxer.getAttributePropertyAsString(element, "crop");
        image_ = URelaxer.getAttributePropertyAsString(element, "image");
        label_ = URelaxer.getAttributePropertyAsString(element, "label");
        disableautoselect_ = URelaxer.getAttributePropertyAsBooleanObject(element, "disableautoselect");
        disabled_ = URelaxer.getAttributePropertyAsBooleanObject(element, "disabled");
        editable_ = URelaxer.getAttributePropertyAsBooleanObject(element, "editable");
        focused_ = URelaxer.getAttributePropertyAsBooleanObject(element, "focused");
        open_ = URelaxer.getAttributePropertyAsBooleanObject(element, "open");
        src_ = URelaxer.getAttributePropertyAsString(element, "src");
        tabindex_ = URelaxer.getAttributePropertyAsBigInteger(element, "tabindex");
        value_ = URelaxer.getAttributePropertyAsString(element, "value");
        setMenupopup(new XulMenupopup(stack));
        xmlPIMap_ = stack.getPIMap();
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new XulMenulist((XulMenulist)this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menulist");
        rNSContext_.setupNamespace(element);
        int size;
        if (this.accesskey_ != null) {
            URelaxer.setAttributePropertyByString(element, "accesskey", this.accesskey_);
        }
        if (this.crop_ != null) {
            URelaxer.setAttributePropertyByString(element, "crop", this.crop_);
        }
        if (this.image_ != null) {
            URelaxer.setAttributePropertyByString(element, "image", this.image_);
        }
        if (this.label_ != null) {
            URelaxer.setAttributePropertyByString(element, "label", this.label_);
        }
        if (this.disableautoselect_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "disableautoselect", this.disableautoselect_);
        }
        if (this.disabled_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "disabled", this.disabled_);
        }
        if (this.editable_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "editable", this.editable_);
        }
        if (this.focused_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "focused", this.focused_);
        }
        if (this.open_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "open", this.open_);
        }
        if (this.src_ != null) {
            URelaxer.setAttributePropertyByString(element, "src", this.src_);
        }
        if (this.tabindex_ != null) {
            URelaxer.setAttributePropertyByBigInteger(element, "tabindex", this.tabindex_);
        }
        if (this.value_ != null) {
            URelaxer.setAttributePropertyByString(element, "value", this.value_);
        }
        this.menupopup_.makeElement(element);
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>XulMenulist</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>XulMenulist</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulMenulist</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulMenulist</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulMenulist</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulMenulist</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the RNSContext property <b>RNSContext</b>.
     *
     * @return RNSContext
     */
    public RNSContext rGetRNSContext() {
        return (rNSContext_);
    }

    /**
     * Sets the RNSContext property <b>RNSContext</b>.
     *
     * @param rNSContext
     */
    public void rSetRNSContext(RNSContext rNSContext) {
        this.rNSContext_ = rNSContext;
    }

    /**
     * Gets the String property <b>accesskey</b>.
     *
     * @return String
     */
    public String getAccesskey() {
        return (accesskey_);
    }

    /**
     * Sets the String property <b>accesskey</b>.
     *
     * @param accesskey
     */
    public void setAccesskey(String accesskey) {
        this.accesskey_ = accesskey;
    }

    /**
     * Gets the String property <b>crop</b>.
     *
     * @return String
     */
    public String getCrop() {
        return (crop_);
    }

    /**
     * Sets the String property <b>crop</b>.
     *
     * @param crop
     */
    public void setCrop(String crop) {
        this.crop_ = crop;
    }

    /**
     * Gets the String property <b>image</b>.
     *
     * @return String
     */
    public String getImage() {
        return (image_);
    }

    /**
     * Sets the String property <b>image</b>.
     *
     * @param image
     */
    public void setImage(String image) {
        this.image_ = image;
    }

    /**
     * Gets the String property <b>label</b>.
     *
     * @return String
     */
    public String getLabel() {
        return (label_);
    }

    /**
     * Sets the String property <b>label</b>.
     *
     * @param label
     */
    public void setLabel(String label) {
        this.label_ = label;
    }

    /**
     * Gets the boolean property <b>disableautoselect</b>.
     *
     * @return boolean
     */
    public boolean getDisableautoselect() {
        if (disableautoselect_ == null) {
            return(false);
        }
        return (disableautoselect_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disableautoselect</b>.
     *
     * @param disableautoselect
     * @return boolean
     */
    public boolean getDisableautoselect(boolean disableautoselect) {
        if (disableautoselect_ == null) {
            return(disableautoselect);
        }
        return (this.disableautoselect_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disableautoselect</b>.
     *
     * @return Boolean
     */
    public Boolean getDisableautoselectAsBoolean() {
        return (disableautoselect_);
    }

    /**
     * Check the boolean property <b>disableautoselect</b>.
     *
     * @return boolean
     */
    public boolean checkDisableautoselect() {
        return (disableautoselect_ != null);
    }

    /**
     * Sets the boolean property <b>disableautoselect</b>.
     *
     * @param disableautoselect
     */
    public void setDisableautoselect(boolean disableautoselect) {
        this.disableautoselect_ = new Boolean(disableautoselect);
    }

    /**
     * Sets the boolean property <b>disableautoselect</b>.
     *
     * @param disableautoselect
     */
    public void setDisableautoselect(Boolean disableautoselect) {
        this.disableautoselect_ = disableautoselect;
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @return boolean
     */
    public boolean getDisabled() {
        if (disabled_ == null) {
            return(false);
        }
        return (disabled_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @param disabled
     * @return boolean
     */
    public boolean getDisabled(boolean disabled) {
        if (disabled_ == null) {
            return(disabled);
        }
        return (this.disabled_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @return Boolean
     */
    public Boolean getDisabledAsBoolean() {
        return (disabled_);
    }

    /**
     * Check the boolean property <b>disabled</b>.
     *
     * @return boolean
     */
    public boolean checkDisabled() {
        return (disabled_ != null);
    }

    /**
     * Sets the boolean property <b>disabled</b>.
     *
     * @param disabled
     */
    public void setDisabled(boolean disabled) {
        this.disabled_ = new Boolean(disabled);
    }

    /**
     * Sets the boolean property <b>disabled</b>.
     *
     * @param disabled
     */
    public void setDisabled(Boolean disabled) {
        this.disabled_ = disabled;
    }

    /**
     * Gets the boolean property <b>editable</b>.
     *
     * @return boolean
     */
    public boolean getEditable() {
        if (editable_ == null) {
            return(false);
        }
        return (editable_.booleanValue());
    }

    /**
     * Gets the boolean property <b>editable</b>.
     *
     * @param editable
     * @return boolean
     */
    public boolean getEditable(boolean editable) {
        if (editable_ == null) {
            return(editable);
        }
        return (this.editable_.booleanValue());
    }

    /**
     * Gets the boolean property <b>editable</b>.
     *
     * @return Boolean
     */
    public Boolean getEditableAsBoolean() {
        return (editable_);
    }

    /**
     * Check the boolean property <b>editable</b>.
     *
     * @return boolean
     */
    public boolean checkEditable() {
        return (editable_ != null);
    }

    /**
     * Sets the boolean property <b>editable</b>.
     *
     * @param editable
     */
    public void setEditable(boolean editable) {
        this.editable_ = new Boolean(editable);
    }

    /**
     * Sets the boolean property <b>editable</b>.
     *
     * @param editable
     */
    public void setEditable(Boolean editable) {
        this.editable_ = editable;
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @return boolean
     */
    public boolean getFocused() {
        if (focused_ == null) {
            return(false);
        }
        return (focused_.booleanValue());
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @param focused
     * @return boolean
     */
    public boolean getFocused(boolean focused) {
        if (focused_ == null) {
            return(focused);
        }
        return (this.focused_.booleanValue());
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @return Boolean
     */
    public Boolean getFocusedAsBoolean() {
        return (focused_);
    }

    /**
     * Check the boolean property <b>focused</b>.
     *
     * @return boolean
     */
    public boolean checkFocused() {
        return (focused_ != null);
    }

    /**
     * Sets the boolean property <b>focused</b>.
     *
     * @param focused
     */
    public void setFocused(boolean focused) {
        this.focused_ = new Boolean(focused);
    }

    /**
     * Sets the boolean property <b>focused</b>.
     *
     * @param focused
     */
    public void setFocused(Boolean focused) {
        this.focused_ = focused;
    }

    /**
     * Gets the boolean property <b>open</b>.
     *
     * @return boolean
     */
    public boolean getOpen() {
        if (open_ == null) {
            return(false);
        }
        return (open_.booleanValue());
    }

    /**
     * Gets the boolean property <b>open</b>.
     *
     * @param open
     * @return boolean
     */
    public boolean getOpen(boolean open) {
        if (open_ == null) {
            return(open);
        }
        return (this.open_.booleanValue());
    }

    /**
     * Gets the boolean property <b>open</b>.
     *
     * @return Boolean
     */
    public Boolean getOpenAsBoolean() {
        return (open_);
    }

    /**
     * Check the boolean property <b>open</b>.
     *
     * @return boolean
     */
    public boolean checkOpen() {
        return (open_ != null);
    }

    /**
     * Sets the boolean property <b>open</b>.
     *
     * @param open
     */
    public void setOpen(boolean open) {
        this.open_ = new Boolean(open);
    }

    /**
     * Sets the boolean property <b>open</b>.
     *
     * @param open
     */
    public void setOpen(Boolean open) {
        this.open_ = open;
    }

    /**
     * Gets the String property <b>src</b>.
     *
     * @return String
     */
    public String getSrc() {
        return (src_);
    }

    /**
     * Sets the String property <b>src</b>.
     *
     * @param src
     */
    public void setSrc(String src) {
        this.src_ = src;
    }

    /**
     * Gets the java.math.BigInteger property <b>tabindex</b>.
     *
     * @return java.math.BigInteger
     */
    public java.math.BigInteger getTabindex() {
        return (tabindex_);
    }

    /**
     * Sets the java.math.BigInteger property <b>tabindex</b>.
     *
     * @param tabindex
     */
    public void setTabindex(java.math.BigInteger tabindex) {
        this.tabindex_ = tabindex;
    }

    /**
     * Gets the String property <b>value</b>.
     *
     * @return String
     */
    public String getValue() {
        return (value_);
    }

    /**
     * Sets the String property <b>value</b>.
     *
     * @param value
     */
    public void setValue(String value) {
        this.value_ = value;
    }

    /**
     * Gets the XulMenupopup property <b>menupopup</b>.
     *
     * @return XulMenupopup
     */
    public XulMenupopup getMenupopup() {
        return (menupopup_);
    }

    /**
     * Sets the XulMenupopup property <b>menupopup</b>.
     *
     * @param menupopup
     */
    public void setMenupopup(XulMenupopup menupopup) {
        this.menupopup_ = menupopup;
        if (menupopup != null) {
            menupopup.rSetParentRNode(this);
        }
    }

    /**
     * Makes an XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "menulist", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (accesskey_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "accesskey", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getAccesskey())));
            buffer.append("\"");
        }
        if (crop_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "crop", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getCrop())));
            buffer.append("\"");
        }
        if (image_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "image", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getImage())));
            buffer.append("\"");
        }
        if (label_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "label", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getLabel())));
            buffer.append("\"");
        }
        if (disableautoselect_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "disableautoselect", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getDisableautoselect()));
            buffer.append("\"");
        }
        if (disabled_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getDisabled()));
            buffer.append("\"");
        }
        if (editable_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "editable", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getEditable()));
            buffer.append("\"");
        }
        if (focused_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getFocused()));
            buffer.append("\"");
        }
        if (open_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "open", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getOpen()));
            buffer.append("\"");
        }
        if (src_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "src", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getSrc())));
            buffer.append("\"");
        }
        if (tabindex_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getTabindex()));
            buffer.append("\"");
        }
        if (value_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.append("\"");
        }
        buffer.append(">");
        menupopup_.makeTextElement(buffer);
        buffer.append("</");
        URelaxer.makeQName(prefix, "menulist", buffer);
        buffer.append(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.write("<");
        URelaxer.makeQName(prefix, "menulist", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (accesskey_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "accesskey", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getAccesskey())));
            buffer.write("\"");
        }
        if (crop_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "crop", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getCrop())));
            buffer.write("\"");
        }
        if (image_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "image", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getImage())));
            buffer.write("\"");
        }
        if (label_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "label", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getLabel())));
            buffer.write("\"");
        }
        if (disableautoselect_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "disableautoselect", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getDisableautoselect()));
            buffer.write("\"");
        }
        if (disabled_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getDisabled()));
            buffer.write("\"");
        }
        if (editable_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "editable", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getEditable()));
            buffer.write("\"");
        }
        if (focused_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getFocused()));
            buffer.write("\"");
        }
        if (open_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "open", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getOpen()));
            buffer.write("\"");
        }
        if (src_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "src", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getSrc())));
            buffer.write("\"");
        }
        if (tabindex_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getTabindex()));
            buffer.write("\"");
        }
        if (value_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.write("\"");
        }
        buffer.write(">");
        menupopup_.makeTextElement(buffer);
        buffer.write("</");
        URelaxer.makeQName(prefix, "menulist", buffer);
        buffer.write(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.print("<");
        URelaxer.makeQName(prefix, "menulist", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (accesskey_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "accesskey", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getAccesskey())));
            buffer.print("\"");
        }
        if (crop_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "crop", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getCrop())));
            buffer.print("\"");
        }
        if (image_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "image", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getImage())));
            buffer.print("\"");
        }
        if (label_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "label", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getLabel())));
            buffer.print("\"");
        }
        if (disableautoselect_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "disableautoselect", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getDisableautoselect()));
            buffer.print("\"");
        }
        if (disabled_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getDisabled()));
            buffer.print("\"");
        }
        if (editable_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "editable", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getEditable()));
            buffer.print("\"");
        }
        if (focused_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getFocused()));
            buffer.print("\"");
        }
        if (open_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "open", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getOpen()));
            buffer.print("\"");
        }
        if (src_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "src", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getSrc())));
            buffer.print("\"");
        }
        if (tabindex_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getTabindex()));
            buffer.print("\"");
        }
        if (value_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.print("\"");
        }
        buffer.print(">");
        menupopup_.makeTextElement(buffer);
        buffer.print("</");
        URelaxer.makeQName(prefix, "menulist", buffer);
        buffer.print(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getAccesskeyAsString() {
        return (URelaxer.getString(getAccesskey()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getCropAsString() {
        return (URelaxer.getString(getCrop()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getImageAsString() {
        return (URelaxer.getString(getImage()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getLabelAsString() {
        return (URelaxer.getString(getLabel()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getDisableautoselectAsString() {
        return (URelaxer.getString(getDisableautoselect()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getDisabledAsString() {
        return (URelaxer.getString(getDisabled()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getEditableAsString() {
        return (URelaxer.getString(getEditable()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getFocusedAsString() {
        return (URelaxer.getString(getFocused()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getOpenAsString() {
        return (URelaxer.getString(getOpen()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getSrcAsString() {
        return (URelaxer.getString(getSrc()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getTabindexAsString() {
        return (URelaxer.getString(getTabindex()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getValueAsString() {
        return (URelaxer.getString(getValue()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setAccesskeyByString(String string) {
        setAccesskey(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setCropByString(String string) {
        setCrop(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setImageByString(String string) {
        setImage(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setLabelByString(String string) {
        setLabel(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setDisableautoselectByString(String string) {
        setDisableautoselect(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setDisabledByString(String string) {
        setDisabled(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setEditableByString(String string) {
        setEditable(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setFocusedByString(String string) {
        setFocused(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setOpenByString(String string) {
        setOpen(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setSrcByString(String string) {
        setSrc(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setTabindexByString(String string) {
        setTabindex(new java.math.BigInteger(string));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setValueByString(String string) {
        setValue(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets PI by name.
     *
     * @param name
     * @return String
     */
    public String rGetPi(String name) {
        return ((String)xmlPIMap_.get(name));
    }

    /**
     * Gets PI map.
     *
     * @return java.util.Map
     */
    public java.util.Map rGetPiMap() {
        return (java.util.Collections.unmodifiableMap(xmlPIMap_));
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public void rSetParentRNode(IRNode parentRNode) {
        this.parentRNode_ = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        if (menupopup_ != null) {
            classNodes.add(menupopup_);
        }
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XulMenulist</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer2.isTargetElement(element, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menulist")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        if (!XulMenupopup.isMatchHungry(target)) {
            return (false);
        }
        $match$ = true;
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulMenulist</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulMenulist</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
