/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>XulRadiogroup</b> is generated from xul-jsf.rng by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <element name="radiogroup">
 *       <ref name="disabled.attrib"/>
 *       <ref name="focused.attrib"/>
 *       <ref name="tabindex.attrib"/>
 *       <ref name="value.attrib"/>
 *       <ref name="Block.model"/>
 *     </element>-->
 * <!-- for javadoc -->
 * <pre> &lt;element name="radiogroup"&gt;
 *       &lt;ref name="disabled.attrib"/&gt;
 *       &lt;ref name="focused.attrib"/&gt;
 *       &lt;ref name="tabindex.attrib"/&gt;
 *       &lt;ref name="value.attrib"/&gt;
 *       &lt;ref name="Block.model"/&gt;
 *     &lt;/element&gt;</pre>
 *
 * @version xul-jsf.rng (Sat Sep 25 09:38:07 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class XulRadiogroup implements java.io.Serializable, Cloneable, IRNSContainer, IXulRadiogroupChoice, IXulTooltipChoice, IRVisitable, IRNode, IXulHboxChoice, IXulStackChoice, IXulVboxChoice, IXulColumnChoice, IXulRowChoice, IXulBoxChoice, IXulDeckChoice, IXulCaptionChoice, IXulGroupboxChoice, IXulTabpanelChoice, IXulArrowscrollboxChoice, IXulRadiogroupClassChoice, IXulWindowChoice {
    private RNSContext rNSContext_ = new RNSContext(this, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
    private Boolean disabled_;
    private Boolean focused_;
    private java.math.BigInteger tabindex_;
    private String value_;
    // List<IXulRadiogroupChoice>
    private java.util.List blockClass_ = new java.util.ArrayList();
    private java.util.Map xmlPIMap_;
    private IRNode parentRNode_;

    /**
     * Creates a <code>XulRadiogroup</code>.
     *
     */
    public XulRadiogroup() {
    }

    /**
     * Creates a <code>XulRadiogroup</code>.
     *
     * @param source
     */
    public XulRadiogroup(XulRadiogroup source) {
        setup(source);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XulRadiogroup(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XulRadiogroup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XulRadiogroup(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>XulRadiogroup</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>XulRadiogroup</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulRadiogroup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the XulRadiogroup <code>source</code>.
     *
     * @param source
     */
    public void setup(XulRadiogroup source) {
        int size;
        disabled_ = source.disabled_;
        focused_ = source.focused_;
        tabindex_ = source.tabindex_;
        value_ = source.value_;
        this.blockClass_.clear();
        size = source.blockClass_.size();
        for (int i = 0;i < size;i++) {
            addBlockClass((IXulRadiogroupChoice)source.getBlockClass(i).clone());
        }
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rNSContext_.declareNamespace(element);
        disabled_ = URelaxer.getAttributePropertyAsBooleanObject(element, "disabled");
        focused_ = URelaxer.getAttributePropertyAsBooleanObject(element, "focused");
        tabindex_ = URelaxer.getAttributePropertyAsBigInteger(element, "tabindex");
        value_ = URelaxer.getAttributePropertyAsString(element, "value");
        blockClass_.clear();
        while (true) {
            if (XulButton.isMatch(stack)) {
                addBlockClass(new XulButton(stack));
            } else if (XulTextbox.isMatch(stack)) {
                addBlockClass(new XulTextbox(stack));
            } else if (XulCommandset.isMatch(stack)) {
                addBlockClass(new XulCommandset(stack));
            } else if (XulLabel.isMatch(stack)) {
                addBlockClass(new XulLabel(stack));
            } else if (XulObserves.isMatch(stack)) {
                addBlockClass(new XulObserves(stack));
            } else if (XulListbox.isMatch(stack)) {
                addBlockClass(new XulListbox(stack));
            } else if (XulRadio.isMatch(stack)) {
                addBlockClass(new XulRadio(stack));
            } else if (XulCheckbox.isMatch(stack)) {
                addBlockClass(new XulCheckbox(stack));
            } else if (XulTree.isMatch(stack)) {
                addBlockClass(new XulTree(stack));
            } else if (XulMenupopup.isMatch(stack)) {
                addBlockClass(new XulMenupopup(stack));
            } else if (XulSplitter.isMatch(stack)) {
                addBlockClass(new XulSplitter(stack));
            } else if (XulTabbox.isMatch(stack)) {
                addBlockClass(new XulTabbox(stack));
            } else if (XulImage.isMatch(stack)) {
                addBlockClass(new XulImage(stack));
            } else if (XulCommand.isMatch(stack)) {
                addBlockClass(new XulCommand(stack));
            } else if (XulDescription.isMatch(stack)) {
                addBlockClass(new XulDescription(stack));
            } else if (XulDeck.isMatch(stack)) {
                addBlockClass(new XulDeck(stack));
            } else if (XulScript.isMatch(stack)) {
                addBlockClass(new XulScript(stack));
            } else if (XulMenubar.isMatch(stack)) {
                addBlockClass(new XulMenubar(stack));
            } else if (XulArrowscrollbox.isMatch(stack)) {
                addBlockClass(new XulArrowscrollbox(stack));
            } else if (XulGroupbox.isMatch(stack)) {
                addBlockClass(new XulGroupbox(stack));
            } else if (XulBox.isMatch(stack)) {
                addBlockClass(new XulBox(stack));
            } else if (XulVbox.isMatch(stack)) {
                addBlockClass(new XulVbox(stack));
            } else if (XulBroadcasterset.isMatch(stack)) {
                addBlockClass(new XulBroadcasterset(stack));
            } else if (XulStack.isMatch(stack)) {
                addBlockClass(new XulStack(stack));
            } else if (XulGrid.isMatch(stack)) {
                addBlockClass(new XulGrid(stack));
            } else if (XulIframe.isMatch(stack)) {
                addBlockClass(new XulIframe(stack));
            } else if (XulKeyset.isMatch(stack)) {
                addBlockClass(new XulKeyset(stack));
            } else if (XulToolbox.isMatch(stack)) {
                addBlockClass(new XulToolbox(stack));
            } else if (XulHbox.isMatch(stack)) {
                addBlockClass(new XulHbox(stack));
            } else if (XulBroadcaster.isMatch(stack)) {
                addBlockClass(new XulBroadcaster(stack));
            } else if (XulSeparator.isMatch(stack)) {
                addBlockClass(new XulSeparator(stack));
            } else if (XulSpacer.isMatch(stack)) {
                addBlockClass(new XulSpacer(stack));
            } else if (XulTemplate.isMatch(stack)) {
                addBlockClass(new XulTemplate(stack));
            } else if (XulMenulist.isMatch(stack)) {
                addBlockClass(new XulMenulist(stack));
            } else if (XulRadiogroup.isMatch(stack)) {
                addBlockClass(new XulRadiogroup(stack));
            } else if (XulPopupset.isMatch(stack)) {
                addBlockClass(new XulPopupset(stack));
            } else {
                break;
            }
        }
        xmlPIMap_ = stack.getPIMap();
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new XulRadiogroup((XulRadiogroup)this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "radiogroup");
        rNSContext_.setupNamespace(element);
        int size;
        if (this.disabled_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "disabled", this.disabled_);
        }
        if (this.focused_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "focused", this.focused_);
        }
        if (this.tabindex_ != null) {
            URelaxer.setAttributePropertyByBigInteger(element, "tabindex", this.tabindex_);
        }
        if (this.value_ != null) {
            URelaxer.setAttributePropertyByString(element, "value", this.value_);
        }
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>XulRadiogroup</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulRadiogroup</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the RNSContext property <b>RNSContext</b>.
     *
     * @return RNSContext
     */
    public RNSContext rGetRNSContext() {
        return (rNSContext_);
    }

    /**
     * Sets the RNSContext property <b>RNSContext</b>.
     *
     * @param rNSContext
     */
    public void rSetRNSContext(RNSContext rNSContext) {
        this.rNSContext_ = rNSContext;
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @return boolean
     */
    public boolean getDisabled() {
        if (disabled_ == null) {
            return(false);
        }
        return (disabled_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @param disabled
     * @return boolean
     */
    public boolean getDisabled(boolean disabled) {
        if (disabled_ == null) {
            return(disabled);
        }
        return (this.disabled_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disabled</b>.
     *
     * @return Boolean
     */
    public Boolean getDisabledAsBoolean() {
        return (disabled_);
    }

    /**
     * Check the boolean property <b>disabled</b>.
     *
     * @return boolean
     */
    public boolean checkDisabled() {
        return (disabled_ != null);
    }

    /**
     * Sets the boolean property <b>disabled</b>.
     *
     * @param disabled
     */
    public void setDisabled(boolean disabled) {
        this.disabled_ = new Boolean(disabled);
    }

    /**
     * Sets the boolean property <b>disabled</b>.
     *
     * @param disabled
     */
    public void setDisabled(Boolean disabled) {
        this.disabled_ = disabled;
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @return boolean
     */
    public boolean getFocused() {
        if (focused_ == null) {
            return(false);
        }
        return (focused_.booleanValue());
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @param focused
     * @return boolean
     */
    public boolean getFocused(boolean focused) {
        if (focused_ == null) {
            return(focused);
        }
        return (this.focused_.booleanValue());
    }

    /**
     * Gets the boolean property <b>focused</b>.
     *
     * @return Boolean
     */
    public Boolean getFocusedAsBoolean() {
        return (focused_);
    }

    /**
     * Check the boolean property <b>focused</b>.
     *
     * @return boolean
     */
    public boolean checkFocused() {
        return (focused_ != null);
    }

    /**
     * Sets the boolean property <b>focused</b>.
     *
     * @param focused
     */
    public void setFocused(boolean focused) {
        this.focused_ = new Boolean(focused);
    }

    /**
     * Sets the boolean property <b>focused</b>.
     *
     * @param focused
     */
    public void setFocused(Boolean focused) {
        this.focused_ = focused;
    }

    /**
     * Gets the java.math.BigInteger property <b>tabindex</b>.
     *
     * @return java.math.BigInteger
     */
    public java.math.BigInteger getTabindex() {
        return (tabindex_);
    }

    /**
     * Sets the java.math.BigInteger property <b>tabindex</b>.
     *
     * @param tabindex
     */
    public void setTabindex(java.math.BigInteger tabindex) {
        this.tabindex_ = tabindex;
    }

    /**
     * Gets the String property <b>value</b>.
     *
     * @return String
     */
    public String getValue() {
        return (value_);
    }

    /**
     * Sets the String property <b>value</b>.
     *
     * @param value
     */
    public void setValue(String value) {
        this.value_ = value;
    }

    /**
     * Gets the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @return IXulRadiogroupChoice[]
     */
    public IXulRadiogroupChoice[] getBlockClass() {
        IXulRadiogroupChoice[] array = new IXulRadiogroupChoice[blockClass_.size()];
        return ((IXulRadiogroupChoice[])blockClass_.toArray(array));
    }

    /**
     * Sets the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @param blockClass
     */
    public void setBlockClass(IXulRadiogroupChoice[] blockClass) {
        this.blockClass_.clear();
        for (int i = 0;i < blockClass.length;i++) {
            addBlockClass(blockClass[i]);
        }
        for (int i = 0;i < blockClass.length;i++) {
            blockClass[i].rSetParentRNode(this);
        }
    }

    /**
     * Sets the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @param blockClass
     */
    public void setBlockClass(IXulRadiogroupChoice blockClass) {
        this.blockClass_.clear();
        addBlockClass(blockClass);
        if (blockClass != null) {
            blockClass.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @param blockClass
     */
    public void addBlockClass(IXulRadiogroupChoice blockClass) {
        this.blockClass_.add(blockClass);
        if (blockClass != null) {
            blockClass.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @param blockClass
     */
    public void addBlockClass(IXulRadiogroupChoice[] blockClass) {
        for (int i = 0;i < blockClass.length;i++) {
            addBlockClass(blockClass[i]);
        }
        for (int i = 0;i < blockClass.length;i++) {
            blockClass[i].rSetParentRNode(this);
        }
    }

    /**
     * Gets number of the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     * @return int
     */
    public int sizeBlockClass() {
        return (blockClass_.size());
    }

    /**
     * Gets the IXulRadiogroupChoice property <b>BlockClass</b> by index.
     *
     * @param index
     * @return IXulRadiogroupChoice
     */
    public IXulRadiogroupChoice getBlockClass(int index) {
        return ((IXulRadiogroupChoice)blockClass_.get(index));
    }

    /**
     * Sets the IXulRadiogroupChoice property <b>BlockClass</b> by index.
     *
     * @param index
     * @param blockClass
     */
    public void setBlockClass(int index, IXulRadiogroupChoice blockClass) {
        this.blockClass_.set(index, blockClass);
        if (blockClass != null) {
            blockClass.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IXulRadiogroupChoice property <b>BlockClass</b> by index.
     *
     * @param index
     * @param blockClass
     */
    public void addBlockClass(int index, IXulRadiogroupChoice blockClass) {
        this.blockClass_.add(index, blockClass);
        if (blockClass != null) {
            blockClass.rSetParentRNode(this);
        }
    }

    /**
     * Remove the IXulRadiogroupChoice property <b>BlockClass</b> by index.
     *
     * @param index
     */
    public void removeBlockClass(int index) {
        this.blockClass_.remove(index);
    }

    /**
     * Remove the IXulRadiogroupChoice property <b>BlockClass</b> by object.
     *
     * @param blockClass
     */
    public void removeBlockClass(IXulRadiogroupChoice blockClass) {
        this.blockClass_.remove(blockClass);
    }

    /**
     * Clear the IXulRadiogroupChoice property <b>BlockClass</b>.
     *
     */
    public void clearBlockClass() {
        this.blockClass_.clear();
    }

    /**
     * Makes an XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (disabled_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getDisabled()));
            buffer.append("\"");
        }
        if (focused_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getFocused()));
            buffer.append("\"");
        }
        if (tabindex_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getTabindex()));
            buffer.append("\"");
        }
        if (value_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.append("\"");
        }
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        buffer.append(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.write("<");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (disabled_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getDisabled()));
            buffer.write("\"");
        }
        if (focused_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getFocused()));
            buffer.write("\"");
        }
        if (tabindex_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getTabindex()));
            buffer.write("\"");
        }
        if (value_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.write("\"");
        }
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.write(">");
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        buffer.write(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.print("<");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (disabled_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getDisabled()));
            buffer.print("\"");
        }
        if (focused_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "focused", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getFocused()));
            buffer.print("\"");
        }
        if (tabindex_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "tabindex", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getTabindex()));
            buffer.print("\"");
        }
        if (value_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getValue())));
            buffer.print("\"");
        }
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.print(">");
        size = this.blockClass_.size();
        for (int i = 0;i < size;i++) {
            IXulRadiogroupChoice value = (IXulRadiogroupChoice)this.blockClass_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</");
        URelaxer.makeQName(prefix, "radiogroup", buffer);
        buffer.print(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getDisabledAsString() {
        return (URelaxer.getString(getDisabled()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getFocusedAsString() {
        return (URelaxer.getString(getFocused()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getTabindexAsString() {
        return (URelaxer.getString(getTabindex()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getValueAsString() {
        return (URelaxer.getString(getValue()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setDisabledByString(String string) {
        setDisabled(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setFocusedByString(String string) {
        setFocused(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setTabindexByString(String string) {
        setTabindex(new java.math.BigInteger(string));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setValueByString(String string) {
        setValue(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets PI by name.
     *
     * @param name
     * @return String
     */
    public String rGetPi(String name) {
        return ((String)xmlPIMap_.get(name));
    }

    /**
     * Gets PI map.
     *
     * @return java.util.Map
     */
    public java.util.Map rGetPiMap() {
        return (java.util.Collections.unmodifiableMap(xmlPIMap_));
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public void rSetParentRNode(IRNode parentRNode) {
        this.parentRNode_ = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(blockClass_);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XulRadiogroup</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer2.isTargetElement(element, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "radiogroup")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (XulButton.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulTextbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulCommandset.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulLabel.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulObserves.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulListbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulRadio.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulCheckbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulTree.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulMenupopup.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulSplitter.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulTabbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulImage.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulCommand.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulDescription.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulDeck.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulScript.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulMenubar.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulArrowscrollbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulGroupbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulBox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulVbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulBroadcasterset.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulStack.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulGrid.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulIframe.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulKeyset.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulToolbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulHbox.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulBroadcaster.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulSeparator.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulSpacer.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulTemplate.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulMenulist.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulRadiogroup.isMatchHungry(target)) {
                $match$ = true;
            } else if (XulPopupset.isMatchHungry(target)) {
                $match$ = true;
            } else {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulRadiogroup</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulRadiogroup</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
