/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.xul.element;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>XulTabs</b> is generated from xul-jsf.rng by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <element name="tabs">
 *       <ref name="closebutton.attrib"/>
 *       <ref name="disableclose.attrib"/>
 *       <ref name="first-tab.attrib"/>
 *       <ref name="last-tab.attrib"/>
 *       <ref name="onclosetab.attrib"/>
 *       <ref name="onselect.attrib"/>
 *       <ref name="setfocus.attrib"/>
 *       <oneOrMore>
 *         <ref name="tab"/>
 *       </oneOrMore>
 *     </element>-->
 * <!-- for javadoc -->
 * <pre> &lt;element name="tabs"&gt;
 *       &lt;ref name="closebutton.attrib"/&gt;
 *       &lt;ref name="disableclose.attrib"/&gt;
 *       &lt;ref name="first-tab.attrib"/&gt;
 *       &lt;ref name="last-tab.attrib"/&gt;
 *       &lt;ref name="onclosetab.attrib"/&gt;
 *       &lt;ref name="onselect.attrib"/&gt;
 *       &lt;ref name="setfocus.attrib"/&gt;
 *       &lt;oneOrMore&gt;
 *         &lt;ref name="tab"/&gt;
 *       &lt;/oneOrMore&gt;
 *     &lt;/element&gt;</pre>
 *
 * @version xul-jsf.rng (Sat Sep 25 09:38:05 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class XulTabs implements java.io.Serializable, Cloneable, IRNSContainer, IRVisitable, IRNode {
    private RNSContext rNSContext_ = new RNSContext(this, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
    private Boolean closebutton_;
    private Boolean disableclose_;
    private Boolean firstTab_;
    private Boolean lastTab_;
    private String onclosetab_;
    private String onselect_;
    private Boolean setfocus_;
    // List<XulTab>
    private java.util.List tab_ = new java.util.ArrayList();
    private java.util.Map xmlPIMap_;
    private IRNode parentRNode_;

    /**
     * Creates a <code>XulTabs</code>.
     *
     */
    public XulTabs() {
    }

    /**
     * Creates a <code>XulTabs</code>.
     *
     * @param source
     */
    public XulTabs(XulTabs source) {
        setup(source);
    }

    /**
     * Creates a <code>XulTabs</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XulTabs(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XulTabs</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XulTabs(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XulTabs</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XulTabs(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>XulTabs</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>XulTabs</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>XulTabs</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>XulTabs</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>XulTabs</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>XulTabs</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public XulTabs(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>XulTabs</code> by the XulTabs <code>source</code>.
     *
     * @param source
     */
    public void setup(XulTabs source) {
        int size;
        closebutton_ = source.closebutton_;
        disableclose_ = source.disableclose_;
        firstTab_ = source.firstTab_;
        lastTab_ = source.lastTab_;
        onclosetab_ = source.onclosetab_;
        onselect_ = source.onselect_;
        setfocus_ = source.setfocus_;
        this.tab_.clear();
        size = source.tab_.size();
        for (int i = 0;i < size;i++) {
            addTab((XulTab)source.getTab(i).clone());
        }
    }

    /**
     * Initializes the <code>XulTabs</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XulTabs</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XulTabs</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rNSContext_.declareNamespace(element);
        closebutton_ = URelaxer.getAttributePropertyAsBooleanObject(element, "closebutton");
        disableclose_ = URelaxer.getAttributePropertyAsBooleanObject(element, "disableclose");
        firstTab_ = URelaxer.getAttributePropertyAsBooleanObject(element, "first-tab");
        lastTab_ = URelaxer.getAttributePropertyAsBooleanObject(element, "last-tab");
        onclosetab_ = URelaxer.getAttributePropertyAsString(element, "onclosetab");
        onselect_ = URelaxer.getAttributePropertyAsString(element, "onselect");
        setfocus_ = URelaxer.getAttributePropertyAsBooleanObject(element, "setfocus");
        tab_.clear();
        while (true) {
            if (XulTab.isMatch(stack)) {
                addTab(new XulTab(stack));
            } else {
                break;
            }
        }
        xmlPIMap_ = stack.getPIMap();
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new XulTabs((XulTabs)this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "tabs");
        rNSContext_.setupNamespace(element);
        int size;
        if (this.closebutton_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "closebutton", this.closebutton_);
        }
        if (this.disableclose_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "disableclose", this.disableclose_);
        }
        if (this.firstTab_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "first-tab", this.firstTab_);
        }
        if (this.lastTab_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "last-tab", this.lastTab_);
        }
        if (this.onclosetab_ != null) {
            URelaxer.setAttributePropertyByString(element, "onclosetab", this.onclosetab_);
        }
        if (this.onselect_ != null) {
            URelaxer.setAttributePropertyByString(element, "onselect", this.onselect_);
        }
        if (this.setfocus_ != null) {
            URelaxer.setAttributePropertyByBoolean(element, "setfocus", this.setfocus_);
        }
        size = this.tab_.size();
        for (int i = 0;i < size;i++) {
            XulTab value = (XulTab)this.tab_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>XulTabs</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>XulTabs</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulTabs</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulTabs</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulTabs</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>XulTabs</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the RNSContext property <b>RNSContext</b>.
     *
     * @return RNSContext
     */
    public RNSContext rGetRNSContext() {
        return (rNSContext_);
    }

    /**
     * Sets the RNSContext property <b>RNSContext</b>.
     *
     * @param rNSContext
     */
    public void rSetRNSContext(RNSContext rNSContext) {
        this.rNSContext_ = rNSContext;
    }

    /**
     * Gets the boolean property <b>closebutton</b>.
     *
     * @return boolean
     */
    public boolean getClosebutton() {
        if (closebutton_ == null) {
            return(false);
        }
        return (closebutton_.booleanValue());
    }

    /**
     * Gets the boolean property <b>closebutton</b>.
     *
     * @param closebutton
     * @return boolean
     */
    public boolean getClosebutton(boolean closebutton) {
        if (closebutton_ == null) {
            return(closebutton);
        }
        return (this.closebutton_.booleanValue());
    }

    /**
     * Gets the boolean property <b>closebutton</b>.
     *
     * @return Boolean
     */
    public Boolean getClosebuttonAsBoolean() {
        return (closebutton_);
    }

    /**
     * Check the boolean property <b>closebutton</b>.
     *
     * @return boolean
     */
    public boolean checkClosebutton() {
        return (closebutton_ != null);
    }

    /**
     * Sets the boolean property <b>closebutton</b>.
     *
     * @param closebutton
     */
    public void setClosebutton(boolean closebutton) {
        this.closebutton_ = new Boolean(closebutton);
    }

    /**
     * Sets the boolean property <b>closebutton</b>.
     *
     * @param closebutton
     */
    public void setClosebutton(Boolean closebutton) {
        this.closebutton_ = closebutton;
    }

    /**
     * Gets the boolean property <b>disableclose</b>.
     *
     * @return boolean
     */
    public boolean getDisableclose() {
        if (disableclose_ == null) {
            return(false);
        }
        return (disableclose_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disableclose</b>.
     *
     * @param disableclose
     * @return boolean
     */
    public boolean getDisableclose(boolean disableclose) {
        if (disableclose_ == null) {
            return(disableclose);
        }
        return (this.disableclose_.booleanValue());
    }

    /**
     * Gets the boolean property <b>disableclose</b>.
     *
     * @return Boolean
     */
    public Boolean getDisablecloseAsBoolean() {
        return (disableclose_);
    }

    /**
     * Check the boolean property <b>disableclose</b>.
     *
     * @return boolean
     */
    public boolean checkDisableclose() {
        return (disableclose_ != null);
    }

    /**
     * Sets the boolean property <b>disableclose</b>.
     *
     * @param disableclose
     */
    public void setDisableclose(boolean disableclose) {
        this.disableclose_ = new Boolean(disableclose);
    }

    /**
     * Sets the boolean property <b>disableclose</b>.
     *
     * @param disableclose
     */
    public void setDisableclose(Boolean disableclose) {
        this.disableclose_ = disableclose;
    }

    /**
     * Gets the boolean property <b>firstTab</b>.
     *
     * @return boolean
     */
    public boolean getFirstTab() {
        if (firstTab_ == null) {
            return(false);
        }
        return (firstTab_.booleanValue());
    }

    /**
     * Gets the boolean property <b>firstTab</b>.
     *
     * @param firstTab
     * @return boolean
     */
    public boolean getFirstTab(boolean firstTab) {
        if (firstTab_ == null) {
            return(firstTab);
        }
        return (this.firstTab_.booleanValue());
    }

    /**
     * Gets the boolean property <b>firstTab</b>.
     *
     * @return Boolean
     */
    public Boolean getFirstTabAsBoolean() {
        return (firstTab_);
    }

    /**
     * Check the boolean property <b>firstTab</b>.
     *
     * @return boolean
     */
    public boolean checkFirstTab() {
        return (firstTab_ != null);
    }

    /**
     * Sets the boolean property <b>firstTab</b>.
     *
     * @param firstTab
     */
    public void setFirstTab(boolean firstTab) {
        this.firstTab_ = new Boolean(firstTab);
    }

    /**
     * Sets the boolean property <b>firstTab</b>.
     *
     * @param firstTab
     */
    public void setFirstTab(Boolean firstTab) {
        this.firstTab_ = firstTab;
    }

    /**
     * Gets the boolean property <b>lastTab</b>.
     *
     * @return boolean
     */
    public boolean getLastTab() {
        if (lastTab_ == null) {
            return(false);
        }
        return (lastTab_.booleanValue());
    }

    /**
     * Gets the boolean property <b>lastTab</b>.
     *
     * @param lastTab
     * @return boolean
     */
    public boolean getLastTab(boolean lastTab) {
        if (lastTab_ == null) {
            return(lastTab);
        }
        return (this.lastTab_.booleanValue());
    }

    /**
     * Gets the boolean property <b>lastTab</b>.
     *
     * @return Boolean
     */
    public Boolean getLastTabAsBoolean() {
        return (lastTab_);
    }

    /**
     * Check the boolean property <b>lastTab</b>.
     *
     * @return boolean
     */
    public boolean checkLastTab() {
        return (lastTab_ != null);
    }

    /**
     * Sets the boolean property <b>lastTab</b>.
     *
     * @param lastTab
     */
    public void setLastTab(boolean lastTab) {
        this.lastTab_ = new Boolean(lastTab);
    }

    /**
     * Sets the boolean property <b>lastTab</b>.
     *
     * @param lastTab
     */
    public void setLastTab(Boolean lastTab) {
        this.lastTab_ = lastTab;
    }

    /**
     * Gets the String property <b>onclosetab</b>.
     *
     * @return String
     */
    public String getOnclosetab() {
        return (onclosetab_);
    }

    /**
     * Sets the String property <b>onclosetab</b>.
     *
     * @param onclosetab
     */
    public void setOnclosetab(String onclosetab) {
        this.onclosetab_ = onclosetab;
    }

    /**
     * Gets the String property <b>onselect</b>.
     *
     * @return String
     */
    public String getOnselect() {
        return (onselect_);
    }

    /**
     * Sets the String property <b>onselect</b>.
     *
     * @param onselect
     */
    public void setOnselect(String onselect) {
        this.onselect_ = onselect;
    }

    /**
     * Gets the boolean property <b>setfocus</b>.
     *
     * @return boolean
     */
    public boolean getSetfocus() {
        if (setfocus_ == null) {
            return(false);
        }
        return (setfocus_.booleanValue());
    }

    /**
     * Gets the boolean property <b>setfocus</b>.
     *
     * @param setfocus
     * @return boolean
     */
    public boolean getSetfocus(boolean setfocus) {
        if (setfocus_ == null) {
            return(setfocus);
        }
        return (this.setfocus_.booleanValue());
    }

    /**
     * Gets the boolean property <b>setfocus</b>.
     *
     * @return Boolean
     */
    public Boolean getSetfocusAsBoolean() {
        return (setfocus_);
    }

    /**
     * Check the boolean property <b>setfocus</b>.
     *
     * @return boolean
     */
    public boolean checkSetfocus() {
        return (setfocus_ != null);
    }

    /**
     * Sets the boolean property <b>setfocus</b>.
     *
     * @param setfocus
     */
    public void setSetfocus(boolean setfocus) {
        this.setfocus_ = new Boolean(setfocus);
    }

    /**
     * Sets the boolean property <b>setfocus</b>.
     *
     * @param setfocus
     */
    public void setSetfocus(Boolean setfocus) {
        this.setfocus_ = setfocus;
    }

    /**
     * Gets the XulTab property <b>tab</b>.
     *
     * @return XulTab[]
     */
    public XulTab[] getTab() {
        XulTab[] array = new XulTab[tab_.size()];
        return ((XulTab[])tab_.toArray(array));
    }

    /**
     * Sets the XulTab property <b>tab</b>.
     *
     * @param tab
     */
    public void setTab(XulTab[] tab) {
        this.tab_.clear();
        for (int i = 0;i < tab.length;i++) {
            addTab(tab[i]);
        }
        for (int i = 0;i < tab.length;i++) {
            tab[i].rSetParentRNode(this);
        }
    }

    /**
     * Sets the XulTab property <b>tab</b>.
     *
     * @param tab
     */
    public void setTab(XulTab tab) {
        this.tab_.clear();
        addTab(tab);
        if (tab != null) {
            tab.rSetParentRNode(this);
        }
    }

    /**
     * Adds the XulTab property <b>tab</b>.
     *
     * @param tab
     */
    public void addTab(XulTab tab) {
        this.tab_.add(tab);
        if (tab != null) {
            tab.rSetParentRNode(this);
        }
    }

    /**
     * Adds the XulTab property <b>tab</b>.
     *
     * @param tab
     */
    public void addTab(XulTab[] tab) {
        for (int i = 0;i < tab.length;i++) {
            addTab(tab[i]);
        }
        for (int i = 0;i < tab.length;i++) {
            tab[i].rSetParentRNode(this);
        }
    }

    /**
     * Gets number of the XulTab property <b>tab</b>.
     *
     * @return int
     */
    public int sizeTab() {
        return (tab_.size());
    }

    /**
     * Gets the XulTab property <b>tab</b> by index.
     *
     * @param index
     * @return XulTab
     */
    public XulTab getTab(int index) {
        return ((XulTab)tab_.get(index));
    }

    /**
     * Sets the XulTab property <b>tab</b> by index.
     *
     * @param index
     * @param tab
     */
    public void setTab(int index, XulTab tab) {
        this.tab_.set(index, tab);
        if (tab != null) {
            tab.rSetParentRNode(this);
        }
    }

    /**
     * Adds the XulTab property <b>tab</b> by index.
     *
     * @param index
     * @param tab
     */
    public void addTab(int index, XulTab tab) {
        this.tab_.add(index, tab);
        if (tab != null) {
            tab.rSetParentRNode(this);
        }
    }

    /**
     * Remove the XulTab property <b>tab</b> by index.
     *
     * @param index
     */
    public void removeTab(int index) {
        this.tab_.remove(index);
    }

    /**
     * Remove the XulTab property <b>tab</b> by object.
     *
     * @param tab
     */
    public void removeTab(XulTab tab) {
        this.tab_.remove(tab);
    }

    /**
     * Clear the XulTab property <b>tab</b>.
     *
     */
    public void clearTab() {
        this.tab_.clear();
    }

    /**
     * Makes an XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "tabs", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (closebutton_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "closebutton", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getClosebutton()));
            buffer.append("\"");
        }
        if (disableclose_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "disableclose", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getDisableclose()));
            buffer.append("\"");
        }
        if (firstTab_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "first-tab", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getFirstTab()));
            buffer.append("\"");
        }
        if (lastTab_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "last-tab", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getLastTab()));
            buffer.append("\"");
        }
        if (onclosetab_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onclosetab", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getOnclosetab())));
            buffer.append("\"");
        }
        if (onselect_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onselect", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getOnselect())));
            buffer.append("\"");
        }
        if (setfocus_ != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "setfocus", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(getSetfocus()));
            buffer.append("\"");
        }
        buffer.append(">");
        size = this.tab_.size();
        for (int i = 0;i < size;i++) {
            XulTab value = (XulTab)this.tab_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</");
        URelaxer.makeQName(prefix, "tabs", buffer);
        buffer.append(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.write("<");
        URelaxer.makeQName(prefix, "tabs", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (closebutton_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "closebutton", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getClosebutton()));
            buffer.write("\"");
        }
        if (disableclose_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "disableclose", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getDisableclose()));
            buffer.write("\"");
        }
        if (firstTab_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "first-tab", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getFirstTab()));
            buffer.write("\"");
        }
        if (lastTab_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "last-tab", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getLastTab()));
            buffer.write("\"");
        }
        if (onclosetab_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "onclosetab", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getOnclosetab())));
            buffer.write("\"");
        }
        if (onselect_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "onselect", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getOnselect())));
            buffer.write("\"");
        }
        if (setfocus_ != null) {
            buffer.write(" ");
            rNSContext_.makeQName("", "setfocus", buffer);
            buffer.write("=\"");
            buffer.write(URelaxer.getString(getSetfocus()));
            buffer.write("\"");
        }
        buffer.write(">");
        size = this.tab_.size();
        for (int i = 0;i < size;i++) {
            XulTab value = (XulTab)this.tab_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</");
        URelaxer.makeQName(prefix, "tabs", buffer);
        buffer.write(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.print("<");
        URelaxer.makeQName(prefix, "tabs", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (closebutton_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "closebutton", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getClosebutton()));
            buffer.print("\"");
        }
        if (disableclose_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "disableclose", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getDisableclose()));
            buffer.print("\"");
        }
        if (firstTab_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "first-tab", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getFirstTab()));
            buffer.print("\"");
        }
        if (lastTab_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "last-tab", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getLastTab()));
            buffer.print("\"");
        }
        if (onclosetab_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "onclosetab", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getOnclosetab())));
            buffer.print("\"");
        }
        if (onselect_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "onselect", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getOnselect())));
            buffer.print("\"");
        }
        if (setfocus_ != null) {
            buffer.print(" ");
            rNSContext_.makeQName("", "setfocus", buffer);
            buffer.print("=\"");
            buffer.print(URelaxer.getString(getSetfocus()));
            buffer.print("\"");
        }
        buffer.print(">");
        size = this.tab_.size();
        for (int i = 0;i < size;i++) {
            XulTab value = (XulTab)this.tab_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</");
        URelaxer.makeQName(prefix, "tabs", buffer);
        buffer.print(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getClosebuttonAsString() {
        return (URelaxer.getString(getClosebutton()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getDisablecloseAsString() {
        return (URelaxer.getString(getDisableclose()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getFirstTabAsString() {
        return (URelaxer.getString(getFirstTab()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getLastTabAsString() {
        return (URelaxer.getString(getLastTab()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getOnclosetabAsString() {
        return (URelaxer.getString(getOnclosetab()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getOnselectAsString() {
        return (URelaxer.getString(getOnselect()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getSetfocusAsString() {
        return (URelaxer.getString(getSetfocus()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setClosebuttonByString(String string) {
        setClosebutton(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setDisablecloseByString(String string) {
        setDisableclose(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setFirstTabByString(String string) {
        setFirstTab(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setLastTabByString(String string) {
        setLastTab(new Boolean(string).booleanValue());
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setOnclosetabByString(String string) {
        setOnclosetab(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setOnselectByString(String string) {
        setOnselect(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setSetfocusByString(String string) {
        setSetfocus(new Boolean(string).booleanValue());
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets PI by name.
     *
     * @param name
     * @return String
     */
    public String rGetPi(String name) {
        return ((String)xmlPIMap_.get(name));
    }

    /**
     * Gets PI map.
     *
     * @return java.util.Map
     */
    public java.util.Map rGetPiMap() {
        return (java.util.Collections.unmodifiableMap(xmlPIMap_));
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public void rSetParentRNode(IRNode parentRNode) {
        this.parentRNode_ = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(tab_);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XulTabs</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer2.isTargetElement(element, "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "tabs")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        if (!XulTab.isMatchHungry(target)) {
            return (false);
        }
        $match$ = true;
        while (true) {
            if (!XulTab.isMatchHungry(target)) {
                break;
            }
            $match$ = true;
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulTabs</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XulTabs</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
