package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.cove.el.CoveElResolver;
import com.netpotlet.xul.component.CaptionComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class CaptionRenderer extends Renderer {

    public CaptionRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        CaptionComponent caption = (CaptionComponent) component;
        try {
            char[] encoded = getEncodedBeginString(caption);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(CaptionComponent caption)
        throws ParseException {
        RNSContext rNSContext_ = caption.xulCaption.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();
        String prefix =
            rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "caption", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (caption.xulCaption.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getAlign())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getAllowevents()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getClassValue())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getCollapsed()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getContainer())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getContainment())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getContext())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getContextmenu())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getDatasources())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getDebug()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getDir())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getEmpty()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getEqualsize())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getFlags())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getFlex()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getHeight()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getHidden()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getId())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getInsertafter())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getInsertbefore())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getLeft()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getMaxheight()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getMaxwidth()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getMenu())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getMinheight()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getMinwidth()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getObserves())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getOrdinal()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getOrient())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getPack())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getPersist())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getPopup())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getPosition())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getRef())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getRemoveelement())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getSortDirection())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getSortResource())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getSortResource2())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getStatustext())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getStyle())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getTemplate())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getTooltip())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getTooltiptext())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getTop()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getUri())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(caption.xulCaption.getWidth()));
            buffer.append("\"");
        }
        if (caption.xulCaption.getAccesskey() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "accesskey", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getAccesskey())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getCrop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "crop", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getCrop())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getImage() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "image", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(caption.xulCaption.getImage())));
            buffer.append("\"");
        }
        if (caption.xulCaption.getLabel() != null) {
            mixed = caption.xulCaption.getLabel();
            resolvedString = CoveElResolver.getResolver().resolveExpression(mixed);
            buffer.append(" ");
            rNSContext_.makeQName("", "label", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(resolvedString)));
            buffer.append("\"");
        }
        if (caption.xulCaption.getBlockClass() != null) {
            caption.xulCaption.getBlockClass().makeTextAttribute(buffer);
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        CaptionComponent caption = (CaptionComponent) component;
        char[] encoded = getEncodedEndString(caption);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(CaptionComponent caption) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = caption.xulCaption.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "caption", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
