package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.ColumnComponent;
import com.netpotlet.xul.element.IXulColumnChoice;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class ColumnRenderer extends Renderer {

    public ColumnRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ColumnComponent column = (ColumnComponent) component;
        try {
            char[] encoded = getEncodedBeginString(column);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(ColumnComponent column)
        throws ParseException {
        RNSContext rNSContext_ = column.xulColumn.rGetRNSContext();
        StringBuffer buffer = new StringBuffer();
        String mixed;
        String resolvedString;
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "column", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (column.xulColumn.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getAlign())));
            buffer.append("\"");
        }
        if (column.xulColumn.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getAllowevents()));
            buffer.append("\"");
        }
        if (column.xulColumn.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (column.xulColumn.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getClassValue())));
            buffer.append("\"");
        }
        if (column.xulColumn.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (column.xulColumn.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getCollapsed()));
            buffer.append("\"");
        }
        if (column.xulColumn.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getContainer())));
            buffer.append("\"");
        }
        if (column.xulColumn.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getContainment())));
            buffer.append("\"");
        }
        if (column.xulColumn.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getContext())));
            buffer.append("\"");
        }
        if (column.xulColumn.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getContextmenu())));
            buffer.append("\"");
        }
        if (column.xulColumn.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getDatasources())));
            buffer.append("\"");
        }
        if (column.xulColumn.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getDebug()));
            buffer.append("\"");
        }
        if (column.xulColumn.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getDir())));
            buffer.append("\"");
        }
        if (column.xulColumn.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getEmpty()));
            buffer.append("\"");
        }
        if (column.xulColumn.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getEqualsize())));
            buffer.append("\"");
        }
        if (column.xulColumn.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getFlags())));
            buffer.append("\"");
        }
        if (column.xulColumn.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getFlex()));
            buffer.append("\"");
        }
        if (column.xulColumn.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getHeight()));
            buffer.append("\"");
        }
        if (column.xulColumn.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getHidden()));
            buffer.append("\"");
        }
        if (column.xulColumn.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getId())));
            buffer.append("\"");
        }
        if (column.xulColumn.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getInsertafter())));
            buffer.append("\"");
        }
        if (column.xulColumn.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getInsertbefore())));
            buffer.append("\"");
        }
        if (column.xulColumn.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getLeft()));
            buffer.append("\"");
        }
        if (column.xulColumn.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getMaxheight()));
            buffer.append("\"");
        }
        if (column.xulColumn.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getMaxwidth()));
            buffer.append("\"");
        }
        if (column.xulColumn.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getMenu())));
            buffer.append("\"");
        }
        if (column.xulColumn.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getMinheight()));
            buffer.append("\"");
        }
        if (column.xulColumn.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getMinwidth()));
            buffer.append("\"");
        }
        if (column.xulColumn.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getObserves())));
            buffer.append("\"");
        }
        if (column.xulColumn.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getOrdinal()));
            buffer.append("\"");
        }
        if (column.xulColumn.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getOrient())));
            buffer.append("\"");
        }
        if (column.xulColumn.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getPack())));
            buffer.append("\"");
        }
        if (column.xulColumn.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getPersist())));
            buffer.append("\"");
        }
        if (column.xulColumn.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getPopup())));
            buffer.append("\"");
        }
        if (column.xulColumn.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getPosition())));
            buffer.append("\"");
        }
        if (column.xulColumn.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getRef())));
            buffer.append("\"");
        }
        if (column.xulColumn.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getRemoveelement())));
            buffer.append("\"");
        }
        if (column.xulColumn.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getSortDirection())));
            buffer.append("\"");
        }
        if (column.xulColumn.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getSortResource())));
            buffer.append("\"");
        }
        if (column.xulColumn.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getSortResource2())));
            buffer.append("\"");
        }
        if (column.xulColumn.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getStatustext())));
            buffer.append("\"");
        }
        if (column.xulColumn.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getStyle())));
            buffer.append("\"");
        }
        if (column.xulColumn.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getTemplate())));
            buffer.append("\"");
        }
        if (column.xulColumn.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getTooltip())));
            buffer.append("\"");
        }
        if (column.xulColumn.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getTooltiptext())));
            buffer.append("\"");
        }
        if (column.xulColumn.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getTop()));
            buffer.append("\"");
        }
        if (column.xulColumn.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(column.xulColumn.getUri())));
            buffer.append("\"");
        }
        if (column.xulColumn.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(column.xulColumn.getWidth()));
            buffer.append("\"");
        }
        int size = column.xulColumn.getBlockClass().length;
        for (int i = 0;i < size;i++) {
            IXulColumnChoice value = 
                (IXulColumnChoice)column.xulColumn.getBlockClass()[i];
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ColumnComponent column = (ColumnComponent) component;
        char[] encoded = getEncodedEndString(column);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(ColumnComponent column) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = column.xulColumn.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "column", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
