package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.ColumnsComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class ColumnsRenderer extends Renderer {

    public ColumnsRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ColumnsComponent columns = (ColumnsComponent) component;
        try {
            char[] encoded = getEncodedBeginString(columns);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(ColumnsComponent columns)
        throws ParseException {
        RNSContext rNSContext_ = columns.xulColumns.rGetRNSContext();
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "columns", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (columns.xulColumns.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getAlign())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getAllowevents()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getClassValue())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getCollapsed()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getContainer())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getContainment())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getContext())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getContextmenu())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getDatasources())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getDebug()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getDir())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getEmpty()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getEqualsize())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getFlags())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getFlex()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getHeight()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getHidden()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getId())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getInsertafter())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getInsertbefore())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getLeft()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getMaxheight()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getMaxwidth()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getMenu())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getMinheight()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getMinwidth()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getObserves())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getOrdinal()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getOrient())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getPack())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getPersist())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getPopup())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getPosition())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getRef())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getRemoveelement())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getSortDirection())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getSortResource())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getSortResource2())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getStatustext())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getStyle())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getTemplate())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getTooltip())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getTooltiptext())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getTop()));
            buffer.append("\"");
        }
        if (columns.xulColumns.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(columns.xulColumns.getUri())));
            buffer.append("\"");
        }
        if (columns.xulColumns.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(columns.xulColumns.getWidth()));
            buffer.append("\"");
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ColumnsComponent columns = (ColumnsComponent) component;
        char[] encoded = getEncodedEndString(columns);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(ColumnsComponent columns) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = columns.xulColumns.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "columns", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
