package com.netpotlet.xul.renderkit;

import java.io.IOException;
import java.io.Writer;

import javax.faces.component.UIComponent;
import javax.faces.context.ResponseWriter;

public class CoveResponseWriter extends ResponseWriter {
    private Writer writer;
    private String contentType;
    private String characterEncoding;

    public CoveResponseWriter(
        Writer writer,
        String contentType,
        String characterEncoding) {
        super();
        this.writer = writer;
        this.contentType = contentType;
        this.characterEncoding = characterEncoding;
    }

    public String getContentType() {
        return contentType;
    }

    public String getCharacterEncoding() {
        return characterEncoding;
    }

    public void setContentType(String contentType) {
        this.contentType = contentType;
    }

    public void setCharacterEncoding(String characterEncoding) {
        this.characterEncoding = characterEncoding;
    }

    public void flush() throws IOException {
    }

    public void startDocument() throws IOException {
    }

    public void endDocument() throws IOException {
        writer.flush();
    }

    public void startElement(String arg0, UIComponent arg1)
        throws IOException {
    }

    public void endElement(String arg0) throws IOException {
    }

    public void writeAttribute(String arg0, Object arg1, String arg2)
        throws IOException {
    }

    public void writeURIAttribute(String arg0, Object arg1, String arg2)
        throws IOException {
    }

    public void writeComment(Object arg0) throws IOException {
    }

    public void writeText(Object arg0, String arg1) throws IOException {
    }

    public void writeText(char[] text, int off, int len) throws IOException {
        if (text != null) {
            writer.write(text, off, len);
        }
    }

    public ResponseWriter cloneWithWriter(Writer arg0) {
        return null;
    }

    public void write(char[] cbuf, int off, int len) throws IOException {
        writer.write(cbuf, off, len);
    }

    public void close() throws IOException {
        writer.close();
    }
}
