package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.GridComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class GridRenderer extends Renderer {

    public GridRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        GridComponent grid = (GridComponent) component;
        try {
            char[] encoded = getEncodedBeginString(grid);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(GridComponent grid)
        throws ParseException {
        RNSContext rNSContext_ = grid.xulGrid.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();
        String prefix = 
            rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "grid", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (grid.xulGrid.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getAlign())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getAllowevents()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getClassValue())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getCollapsed()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getContainer())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getContainment())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getContext())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getContextmenu())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getDatasources())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getDebug()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getDir())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getEmpty()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getEqualsize())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getFlags())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getFlex()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getHeight()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getHidden()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getId())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getInsertafter())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getInsertbefore())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getLeft()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getMaxheight()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getMaxwidth()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getMenu())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getMinheight()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getMinwidth()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getObserves())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getOrdinal()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getOrient())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getPack())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getPersist())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getPopup())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getPosition())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getRef())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getRemoveelement())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getSortDirection())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getSortResource())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getSortResource2())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getStatustext())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getStyle())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getTemplate())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getTooltip())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getTooltiptext())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getTop()));
            buffer.append("\"");
        }
        if (grid.xulGrid.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(grid.xulGrid.getUri())));
            buffer.append("\"");
        }
        if (grid.xulGrid.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(grid.xulGrid.getWidth()));
            buffer.append("\"");
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        GridComponent grid = (GridComponent) component;
        char[] encoded = getEncodedEndString(grid);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(GridComponent grid) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = grid.xulGrid.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "grid", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
