package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.GroupboxComponent;
import com.netpotlet.xul.element.IXulGroupboxChoice;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class GroupboxRenderer extends Renderer {

    public GroupboxRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        GroupboxComponent groupbox = (GroupboxComponent) component;
        try {
            char[] encoded = getEncodedBeginString(groupbox);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(GroupboxComponent groupbox)
        throws ParseException {
        RNSContext rNSContext_ = groupbox.xulGroupbox.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "groupbox", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (groupbox.xulGroupbox.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getAlign())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getAllowevents()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getClassValue())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getCollapsed()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getContainer())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getContainment())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getContext())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getContextmenu())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getDatasources())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getDebug()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getDir())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getEmpty()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getEqualsize())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getFlags())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getFlex()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getHeight()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getHidden()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getId())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getInsertafter())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getInsertbefore())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getLeft()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getMaxheight()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getMaxwidth()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getMenu())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getMinheight()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getMinwidth()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getObserves())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getOrdinal()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getOrient())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getPack())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getPersist())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getPopup())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getPosition())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getRef())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getRemoveelement())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getSortDirection())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getSortResource())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getSortResource2())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getStatustext())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getStyle())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getTemplate())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getTooltip())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getTooltiptext())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getTop()));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(groupbox.xulGroupbox.getUri())));
            buffer.append("\"");
        }
        if (groupbox.xulGroupbox.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(groupbox.xulGroupbox.getWidth()));
            buffer.append("\"");
        }
        int size = groupbox.xulGroupbox.getBlockClass().length;
        for (int i = 0;i < size;i++) {
            IXulGroupboxChoice value =
                groupbox.xulGroupbox.getBlockClass()[i];
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        GroupboxComponent groupbox = (GroupboxComponent) component;
        char[] encoded = getEncodedEndString(groupbox);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(GroupboxComponent groupbox) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = groupbox.xulGroupbox.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "groupbox", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
