package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.cove.el.CoveElResolver;
import com.netpotlet.xul.component.LabelComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class LabelRenderer extends Renderer {

    public LabelRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        LabelComponent label = (LabelComponent) component;
        try {
            char[] encoded = getEncodedBeginString(label);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(LabelComponent label)
        throws ParseException {
        RNSContext rNSContext_ = label.xulLabel.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "label", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (label.xulLabel.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getAlign())));
            buffer.append("\"");
        }
        if (label.xulLabel.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getAllowevents()));
            buffer.append("\"");
        }
        if (label.xulLabel.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (label.xulLabel.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getClassValue())));
            buffer.append("\"");
        }
        if (label.xulLabel.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (label.xulLabel.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getCollapsed()));
            buffer.append("\"");
        }
        if (label.xulLabel.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getContainer())));
            buffer.append("\"");
        }
        if (label.xulLabel.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getContainment())));
            buffer.append("\"");
        }
        if (label.xulLabel.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getContext())));
            buffer.append("\"");
        }
        if (label.xulLabel.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getContextmenu())));
            buffer.append("\"");
        }
        if (label.xulLabel.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getDatasources())));
            buffer.append("\"");
        }
        if (label.xulLabel.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getDebug()));
            buffer.append("\"");
        }
        if (label.xulLabel.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getDir())));
            buffer.append("\"");
        }
        if (label.xulLabel.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getEmpty()));
            buffer.append("\"");
        }
        if (label.xulLabel.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getEqualsize())));
            buffer.append("\"");
        }
        if (label.xulLabel.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getFlags())));
            buffer.append("\"");
        }
        if (label.xulLabel.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getFlex()));
            buffer.append("\"");
        }
        if (label.xulLabel.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getHeight()));
            buffer.append("\"");
        }
        if (label.xulLabel.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getHidden()));
            buffer.append("\"");
        }
        if (label.xulLabel.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getId())));
            buffer.append("\"");
        }
        if (label.xulLabel.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getInsertafter())));
            buffer.append("\"");
        }
        if (label.xulLabel.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getInsertbefore())));
            buffer.append("\"");
        }
        if (label.xulLabel.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getLeft()));
            buffer.append("\"");
        }
        if (label.xulLabel.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getMaxheight()));
            buffer.append("\"");
        }
        if (label.xulLabel.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getMaxwidth()));
            buffer.append("\"");
        }
        if (label.xulLabel.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getMenu())));
            buffer.append("\"");
        }
        if (label.xulLabel.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getMinheight()));
            buffer.append("\"");
        }
        if (label.xulLabel.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getMinwidth()));
            buffer.append("\"");
        }
        if (label.xulLabel.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getObserves())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getOrdinal()));
            buffer.append("\"");
        }
        if (label.xulLabel.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOrient())));
            buffer.append("\"");
        }
        if (label.xulLabel.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getPack())));
            buffer.append("\"");
        }
        if (label.xulLabel.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getPersist())));
            buffer.append("\"");
        }
        if (label.xulLabel.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getPopup())));
            buffer.append("\"");
        }
        if (label.xulLabel.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getPosition())));
            buffer.append("\"");
        }
        if (label.xulLabel.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getRef())));
            buffer.append("\"");
        }
        if (label.xulLabel.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getRemoveelement())));
            buffer.append("\"");
        }
        if (label.xulLabel.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getSortDirection())));
            buffer.append("\"");
        }
        if (label.xulLabel.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getSortResource())));
            buffer.append("\"");
        }
        if (label.xulLabel.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getSortResource2())));
            buffer.append("\"");
        }
        if (label.xulLabel.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getStatustext())));
            buffer.append("\"");
        }
        if (label.xulLabel.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getStyle())));
            buffer.append("\"");
        }
        if (label.xulLabel.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getTemplate())));
            buffer.append("\"");
        }
        if (label.xulLabel.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getTooltip())));
            buffer.append("\"");
        }
        if (label.xulLabel.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getTooltiptext())));
            buffer.append("\"");
        }
        if (label.xulLabel.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getTop()));
            buffer.append("\"");
        }
        if (label.xulLabel.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getUri())));
            buffer.append("\"");
        }
        if (label.xulLabel.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getWidth()));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnclick() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onclick", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnclick())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnmousedown() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmousedown", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnmousedown())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnmouseup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnmouseup())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnmouseover() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseover", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnmouseover())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnmousemove() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmousemove", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnmousemove())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnmouseout() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseout", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnmouseout())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOncommand() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "oncommand", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOncommand())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnkeypress() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeypress", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnkeypress())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnkeydown() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeydown", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnkeydown())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnkeyup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeyup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnkeyup())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnfocus() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onfocus", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnfocus())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnblur() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onblur", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnblur())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnload() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onload", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnload())));
            buffer.append("\"");
        }
        if (label.xulLabel.getOnunload() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onunload", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getOnunload())));
            buffer.append("\"");
        }
        if (label.xulLabel.getAccesskey() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "accesskey", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getAccesskey())));
            buffer.append("\"");
        }
        if (label.xulLabel.getControl() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "control", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getControl())));
            buffer.append("\"");
        }
        if (label.xulLabel.getCrop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "crop", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getCrop())));
            buffer.append("\"");
        }
        if (label.xulLabel.getDisabled() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "disabled", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(label.xulLabel.getDisabled()));
            buffer.append("\"");
        }
        if (label.xulLabel.getValue() !=  null) {
            mixed = label.xulLabel.getValue();
            resolvedString = CoveElResolver.getResolver().resolveExpression(mixed);
            buffer.append(" ");
            rNSContext_.makeQName("", "value", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(label.xulLabel.getValue())));
            buffer.append("\"");
        }
        buffer.append(">");

        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        LabelComponent label = (LabelComponent) component;
        char[] encoded = getEncodedEndString(label);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(LabelComponent label) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = label.xulLabel.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "label", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
