package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.RowComponent;
import com.netpotlet.xul.element.IXulRowChoice;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class RowRenderer extends Renderer {

    public RowRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        RowComponent row = (RowComponent) component;
        try {
            char[] encoded = getEncodedBeginString(row);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(RowComponent row)
        throws ParseException {
        RNSContext rNSContext_ = row.xulRow.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "row", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (row.xulRow.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getAlign())));
            buffer.append("\"");
        }
        if (row.xulRow.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getAllowevents()));
            buffer.append("\"");
        }
        if (row.xulRow.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (row.xulRow.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getClassValue())));
            buffer.append("\"");
        }
        if (row.xulRow.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (row.xulRow.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getCollapsed()));
            buffer.append("\"");
        }
        if (row.xulRow.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getContainer())));
            buffer.append("\"");
        }
        if (row.xulRow.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getContainment())));
            buffer.append("\"");
        }
        if (row.xulRow.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getContext())));
            buffer.append("\"");
        }
        if (row.xulRow.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getContextmenu())));
            buffer.append("\"");
        }
        if (row.xulRow.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getDatasources())));
            buffer.append("\"");
        }
        if (row.xulRow.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getDebug()));
            buffer.append("\"");
        }
        if (row.xulRow.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getDir())));
            buffer.append("\"");
        }
        if (row.xulRow.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getEmpty()));
            buffer.append("\"");
        }
        if (row.xulRow.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getEqualsize())));
            buffer.append("\"");
        }
        if (row.xulRow.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getFlags())));
            buffer.append("\"");
        }
        if (row.xulRow.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getFlex()));
            buffer.append("\"");
        }
        if (row.xulRow.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getHeight()));
            buffer.append("\"");
        }
        if (row.xulRow.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getHidden()));
            buffer.append("\"");
        }
        if (row.xulRow.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getId())));
            buffer.append("\"");
        }
        if (row.xulRow.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getInsertafter())));
            buffer.append("\"");
        }
        if (row.xulRow.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getInsertbefore())));
            buffer.append("\"");
        }
        if (row.xulRow.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getLeft()));
            buffer.append("\"");
        }
        if (row.xulRow.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getMaxheight()));
            buffer.append("\"");
        }
        if (row.xulRow.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getMaxwidth()));
            buffer.append("\"");
        }
        if (row.xulRow.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getMenu())));
            buffer.append("\"");
        }
        if (row.xulRow.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getMinheight()));
            buffer.append("\"");
        }
        if (row.xulRow.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getMinwidth()));
            buffer.append("\"");
        }
        if (row.xulRow.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getObserves())));
            buffer.append("\"");
        }
        if (row.xulRow.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getOrdinal()));
            buffer.append("\"");
        }
        if (row.xulRow.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getOrient())));
            buffer.append("\"");
        }
        if (row.xulRow.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getPack())));
            buffer.append("\"");
        }
        if (row.xulRow.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getPersist())));
            buffer.append("\"");
        }
        if (row.xulRow.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getPopup())));
            buffer.append("\"");
        }
        if (row.xulRow.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getPosition())));
            buffer.append("\"");
        }
        if (row.xulRow.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getRef())));
            buffer.append("\"");
        }
        if (row.xulRow.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getRemoveelement())));
            buffer.append("\"");
        }
        if (row.xulRow.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getSortDirection())));
            buffer.append("\"");
        }
        if (row.xulRow.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getSortResource())));
            buffer.append("\"");
        }
        if (row.xulRow.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getSortResource2())));
            buffer.append("\"");
        }
        if (row.xulRow.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getStatustext())));
            buffer.append("\"");
        }
        if (row.xulRow.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getStyle())));
            buffer.append("\"");
        }
        if (row.xulRow.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getTemplate())));
            buffer.append("\"");
        }
        if (row.xulRow.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getTooltip())));
            buffer.append("\"");
        }
        if (row.xulRow.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getTooltiptext())));
            buffer.append("\"");
        }
        if (row.xulRow.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getTop()));
            buffer.append("\"");
        }
        if (row.xulRow.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(row.xulRow.getUri())));
            buffer.append("\"");
        }
        if (row.xulRow.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(row.xulRow.getWidth()));
            buffer.append("\"");
        }
        int size = row.xulRow.getBlockClass().length;
        for (int i = 0;i < size;i++) {
            IXulRowChoice value = row.xulRow.getBlockClass()[i];
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");



        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        RowComponent row = (RowComponent) component;
        char[] encoded = getEncodedEndString(row);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(RowComponent row) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = row.xulRow.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "row", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
