package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.RowsComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class RowsRenderer extends Renderer {

    public RowsRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        RowsComponent rows = (RowsComponent) component;
        try {
            char[] encoded = getEncodedBeginString(rows);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(RowsComponent rows)
        throws ParseException {
        RNSContext rNSContext_ = rows.xulRows.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "rows", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (rows.xulRows.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getAlign())));
            buffer.append("\"");
        }
        if (rows.xulRows.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getAllowevents()));
            buffer.append("\"");
        }
        if (rows.xulRows.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (rows.xulRows.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getClassValue())));
            buffer.append("\"");
        }
        if (rows.xulRows.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (rows.xulRows.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getCollapsed()));
            buffer.append("\"");
        }
        if (rows.xulRows.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getContainer())));
            buffer.append("\"");
        }
        if (rows.xulRows.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getContainment())));
            buffer.append("\"");
        }
        if (rows.xulRows.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getContext())));
            buffer.append("\"");
        }
        if (rows.xulRows.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getContextmenu())));
            buffer.append("\"");
        }
        if (rows.xulRows.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getDatasources())));
            buffer.append("\"");
        }
        if (rows.xulRows.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getDebug()));
            buffer.append("\"");
        }
        if (rows.xulRows.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getDir())));
            buffer.append("\"");
        }
        if (rows.xulRows.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getEmpty()));
            buffer.append("\"");
        }
        if (rows.xulRows.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getEqualsize())));
            buffer.append("\"");
        }
        if (rows.xulRows.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getFlags())));
            buffer.append("\"");
        }
        if (rows.xulRows.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getFlex()));
            buffer.append("\"");
        }
        if (rows.xulRows.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getHeight()));
            buffer.append("\"");
        }
        if (rows.xulRows.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getHidden()));
            buffer.append("\"");
        }
        if (rows.xulRows.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getId())));
            buffer.append("\"");
        }
        if (rows.xulRows.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getInsertafter())));
            buffer.append("\"");
        }
        if (rows.xulRows.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getInsertbefore())));
            buffer.append("\"");
        }
        if (rows.xulRows.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getLeft()));
            buffer.append("\"");
        }
        if (rows.xulRows.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getMaxheight()));
            buffer.append("\"");
        }
        if (rows.xulRows.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getMaxwidth()));
            buffer.append("\"");
        }
        if (rows.xulRows.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getMenu())));
            buffer.append("\"");
        }
        if (rows.xulRows.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getMinheight()));
            buffer.append("\"");
        }
        if (rows.xulRows.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getMinwidth()));
            buffer.append("\"");
        }
        if (rows.xulRows.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getObserves())));
            buffer.append("\"");
        }
        if (rows.xulRows.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getOrdinal()));
            buffer.append("\"");
        }
        if (rows.xulRows.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getOrient())));
            buffer.append("\"");
        }
        if (rows.xulRows.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getPack())));
            buffer.append("\"");
        }
        if (rows.xulRows.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getPersist())));
            buffer.append("\"");
        }
        if (rows.xulRows.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getPopup())));
            buffer.append("\"");
        }
        if (rows.xulRows.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getPosition())));
            buffer.append("\"");
        }
        if (rows.xulRows.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getRef())));
            buffer.append("\"");
        }
        if (rows.xulRows.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getRemoveelement())));
            buffer.append("\"");
        }
        if (rows.xulRows.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getSortDirection())));
            buffer.append("\"");
        }
        if (rows.xulRows.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getSortResource())));
            buffer.append("\"");
        }
        if (rows.xulRows.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getSortResource2())));
            buffer.append("\"");
        }
        if (rows.xulRows.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getStatustext())));
            buffer.append("\"");
        }
        if (rows.xulRows.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getStyle())));
            buffer.append("\"");
        }
        if (rows.xulRows.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getTemplate())));
            buffer.append("\"");
        }
        if (rows.xulRows.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getTooltip())));
            buffer.append("\"");
        }
        if (rows.xulRows.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getTooltiptext())));
            buffer.append("\"");
        }
        if (rows.xulRows.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getTop()));
            buffer.append("\"");
        }
        if (rows.xulRows.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(rows.xulRows.getUri())));
            buffer.append("\"");
        }
        if (rows.xulRows.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(rows.xulRows.getWidth()));
            buffer.append("\"");
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        RowsComponent rows = (RowsComponent) component;
        char[] encoded = getEncodedEndString(rows);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(RowsComponent rows) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = rows.xulRows.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "rows", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
