package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.cove.el.CoveElResolver;
import com.netpotlet.xul.component.ScriptComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class ScriptRenderer extends Renderer {

    public ScriptRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ScriptComponent script = (ScriptComponent) component;
        try {
            char[] encoded = getEncodedBeginString(script);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(ScriptComponent script)
        throws ParseException {
        RNSContext rNSContext_ = script.xulScript.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "script", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (script.xulScript.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getAlign())));
            buffer.append("\"");
        }
        if (script.xulScript.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getAllowevents()));
            buffer.append("\"");
        }
        if (script.xulScript.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (script.xulScript.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getClassValue())));
            buffer.append("\"");
        }
        if (script.xulScript.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (script.xulScript.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getCollapsed()));
            buffer.append("\"");
        }
        if (script.xulScript.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getContainer())));
            buffer.append("\"");
        }
        if (script.xulScript.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getContainment())));
            buffer.append("\"");
        }
        if (script.xulScript.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getContext())));
            buffer.append("\"");
        }
        if (script.xulScript.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getContextmenu())));
            buffer.append("\"");
        }
        if (script.xulScript.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getDatasources())));
            buffer.append("\"");
        }
        if (script.xulScript.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getDebug()));
            buffer.append("\"");
        }
        if (script.xulScript.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getDir())));
            buffer.append("\"");
        }
        if (script.xulScript.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getEmpty()));
            buffer.append("\"");
        }
        if (script.xulScript.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getEqualsize())));
            buffer.append("\"");
        }
        if (script.xulScript.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getFlags())));
            buffer.append("\"");
        }
        if (script.xulScript.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getFlex()));
            buffer.append("\"");
        }
        if (script.xulScript.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getHeight()));
            buffer.append("\"");
        }
        if (script.xulScript.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getHidden()));
            buffer.append("\"");
        }
        if (script.xulScript.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getId())));
            buffer.append("\"");
        }
        if (script.xulScript.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getInsertafter())));
            buffer.append("\"");
        }
        if (script.xulScript.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getInsertbefore())));
            buffer.append("\"");
        }
        if (script.xulScript.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getLeft()));
            buffer.append("\"");
        }
        if (script.xulScript.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getMaxheight()));
            buffer.append("\"");
        }
        if (script.xulScript.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getMaxwidth()));
            buffer.append("\"");
        }
        if (script.xulScript.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getMenu())));
            buffer.append("\"");
        }
        if (script.xulScript.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getMinheight()));
            buffer.append("\"");
        }
        if (script.xulScript.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getMinwidth()));
            buffer.append("\"");
        }
        if (script.xulScript.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getObserves())));
            buffer.append("\"");
        }
        if (script.xulScript.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getOrdinal()));
            buffer.append("\"");
        }
        if (script.xulScript.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getOrient())));
            buffer.append("\"");
        }
        if (script.xulScript.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getPack())));
            buffer.append("\"");
        }
        if (script.xulScript.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getPersist())));
            buffer.append("\"");
        }
        if (script.xulScript.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getPopup())));
            buffer.append("\"");
        }
        if (script.xulScript.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getPosition())));
            buffer.append("\"");
        }
        if (script.xulScript.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getRef())));
            buffer.append("\"");
        }
        if (script.xulScript.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getRemoveelement())));
            buffer.append("\"");
        }
        if (script.xulScript.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getSortDirection())));
            buffer.append("\"");
        }
        if (script.xulScript.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getSortResource())));
            buffer.append("\"");
        }
        if (script.xulScript.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getSortResource2())));
            buffer.append("\"");
        }
        if (script.xulScript.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getStatustext())));
            buffer.append("\"");
        }
        if (script.xulScript.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getStyle())));
            buffer.append("\"");
        }
        if (script.xulScript.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getTemplate())));
            buffer.append("\"");
        }
        if (script.xulScript.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getTooltip())));
            buffer.append("\"");
        }
        if (script.xulScript.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getTooltiptext())));
            buffer.append("\"");
        }
        if (script.xulScript.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getTop()));
            buffer.append("\"");
        }
        if (script.xulScript.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getUri())));
            buffer.append("\"");
        }
        if (script.xulScript.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(script.xulScript.getWidth()));
            buffer.append("\"");
	}        
        if (script.xulScript.getSrc() != null) {
            mixed = script.xulScript.getSrc();
            resolvedString = CoveElResolver.getResolver().resolveExpression(mixed);
            buffer.append(" ");
            rNSContext_.makeQName("", "src", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(resolvedString)));
            buffer.append("\"");
        }
        if (script.xulScript.getType() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "type", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(script.xulScript.getType())));
            buffer.append("\"");
        }
        buffer.append(">");
        buffer.append(URelaxer.escapeCharData(URelaxer.getString(script.xulScript.getContent())));
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        ScriptComponent script = (ScriptComponent) component;
        char[] encoded = getEncodedEndString(script);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(ScriptComponent script) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = script.xulScript.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "script", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
