package com.netpotlet.xul.renderkit;

import java.io.IOException;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.xul.component.SpacerComponent;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class SpacerRenderer extends Renderer {

    public SpacerRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        SpacerComponent spacer = (SpacerComponent) component;
        try {
            char[] encoded = getEncodedBeginString(spacer);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(SpacerComponent spacer)
        throws ParseException {
        RNSContext rNSContext_ = spacer.xulSpacer.rGetRNSContext();
        String mixed;
        String resolveString;
        StringBuffer buffer = new StringBuffer();

        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "spacer", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (spacer.xulSpacer.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getAlign())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getAllowevents()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getClassValue())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getCollapsed()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getContainer())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getContainment())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getContext())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getContextmenu())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getDatasources())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getDebug()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getDir())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getEmpty()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getEqualsize())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getFlags())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getFlex()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getHeight()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getHidden()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getId())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getInsertafter())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getInsertbefore())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getLeft()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getMaxheight()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getMaxwidth()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getMenu())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getMinheight()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getMinwidth()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getObserves())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getOrdinal()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getOrient())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getPack())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getPersist())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getPopup())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getPosition())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getRef())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getRemoveelement())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getSortDirection())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getSortResource())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getSortResource2())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getStatustext())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getStyle())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getTemplate())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getTooltip())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getTooltiptext())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getTop()));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(spacer.xulSpacer.getUri())));
            buffer.append("\"");
        }
        if (spacer.xulSpacer.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(spacer.xulSpacer.getWidth()));
            buffer.append("\"");
        }
        buffer.append(">");

        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        SpacerComponent spacer = (SpacerComponent) component;
        char[] encoded = getEncodedEndString(spacer);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(SpacerComponent spacer) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = spacer.xulSpacer.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "spacer", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
