package com.netpotlet.xul.renderkit;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import org.apache.commons.el.parser.ParseException;

import com.netpotlet.cove.el.CoveElResolver;
import com.netpotlet.xul.component.WindowComponent;
import com.netpotlet.xul.element.IXulWindowChoice;
import com.netpotlet.xul.element.RNSContext;
import com.netpotlet.xul.element.URelaxer;

public class WindowRenderer extends Renderer {

    public WindowRenderer() {
        super();
    }

    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        WindowComponent window = (WindowComponent) component;
        try {
            char[] encoded = getEncodedBeginString(window);
            ResponseWriter writer = context.getResponseWriter();
            writer.writeText(encoded, 0, encoded.length);
        } catch (ParseException e) {
            throw new FacesException(e);
        }
    }

    private char[] getEncodedBeginString(WindowComponent window)
        throws ParseException {
        RNSContext rNSContext_ = window.xulWindow.rGetRNSContext();
        String mixed;
        String resolvedString;
        StringBuffer buffer = new StringBuffer();
        buffer.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
        Map map = window.xulWindow.rGetPiMap();
        Iterator iterator = map.keySet().iterator();
        while (iterator.hasNext()) {
            String key = (String)iterator.next();
            String value = (String)map.get(key);
            buffer.append("<?").append(key).append(" ");
            buffer.append(value).append("?>");
        }
        String prefix = rNSContext_.getPrefixByUri("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("<");
        URelaxer.makeQName(prefix, "window", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (window.xulWindow.getAlign() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "align", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getAlign())));
            buffer.append("\"");
        }
        if (window.xulWindow.getAllowevents() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allowevents", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getAllowevents()));
            buffer.append("\"");
        }
        if (window.xulWindow.getAllownegativeassertions() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "allownegativeassertions", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getAllownegativeassertions()));
            buffer.append("\"");
        }
        if (window.xulWindow.getClassValue() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "class", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getClassValue())));
            buffer.append("\"");
        }
        if (window.xulWindow.getCoalesceduplicatearcs() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "coalesceduplicatearcs", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getCoalesceduplicatearcs()));
            buffer.append("\"");
        }
        if (window.xulWindow.getCollapsed() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "collapsed", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getCollapsed()));
            buffer.append("\"");
        }
        if (window.xulWindow.getContainer() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "container", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getContainer())));
            buffer.append("\"");
        }
        if (window.xulWindow.getContainment() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "containment", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getContainment())));
            buffer.append("\"");
        }
        if (window.xulWindow.getContext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "context", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getContext())));
            buffer.append("\"");
        }
        if (window.xulWindow.getContextmenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "contextmenu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getContextmenu())));
            buffer.append("\"");
        }
        if (window.xulWindow.getDatasources() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "datasources", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getDatasources())));
            buffer.append("\"");
        }
        if (window.xulWindow.getDebug() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "debug", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getDebug()));
            buffer.append("\"");
        }
        if (window.xulWindow.getDir() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "dir", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getDir())));
            buffer.append("\"");
        }
        if (window.xulWindow.getEmpty() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "empty", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getEmpty()));
            buffer.append("\"");
        }
        if (window.xulWindow.getEqualsize() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "equalsize", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getEqualsize())));
            buffer.append("\"");
        }
        if (window.xulWindow.getFlags() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flags", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getFlags())));
            buffer.append("\"");
        }
        if (window.xulWindow.getFlex() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "flex", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getFlex()));
            buffer.append("\"");
        }
        if (window.xulWindow.getHeight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "height", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getHeight()));
            buffer.append("\"");
        }
        if (window.xulWindow.getHidden() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidden", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getHidden()));
            buffer.append("\"");
        }
        if (window.xulWindow.getId() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "id", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getId())));
            buffer.append("\"");
        }
        if (window.xulWindow.getInsertafter() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertafter", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getInsertafter())));
            buffer.append("\"");
        }
        if (window.xulWindow.getInsertbefore() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "insertbefore", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getInsertbefore())));
            buffer.append("\"");
        }
        if (window.xulWindow.getLeft() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "left", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getLeft()));
            buffer.append("\"");
        }
        if (window.xulWindow.getMaxheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getMaxheight()));
            buffer.append("\"");
        }
        if (window.xulWindow.getMaxwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "maxwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getMaxwidth()));
            buffer.append("\"");
        }
        if (window.xulWindow.getMenu() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "menu", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getMenu())));
            buffer.append("\"");
        }
        if (window.xulWindow.getMinheight() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minheight", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getMinheight()));
            buffer.append("\"");
        }
        if (window.xulWindow.getMinwidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "minwidth", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getMinwidth()));
            buffer.append("\"");
        }
        if (window.xulWindow.getObserves() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "observes", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getObserves())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOrdinal() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ordinal", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getOrdinal()));
            buffer.append("\"");
        }
        if (window.xulWindow.getOrient() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "orient", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOrient())));
            buffer.append("\"");
        }
        if (window.xulWindow.getPack() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "pack", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getPack())));
            buffer.append("\"");
        }
        if (window.xulWindow.getPersist() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "persist", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getPersist())));
            buffer.append("\"");
        }
        if (window.xulWindow.getPopup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "popup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getPopup())));
            buffer.append("\"");
        }
        if (window.xulWindow.getPosition() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "position", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getPosition())));
            buffer.append("\"");
        }
        if (window.xulWindow.getRef() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "ref", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getRef())));
            buffer.append("\"");
        }
        if (window.xulWindow.getRemoveelement() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "removeelement", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getRemoveelement())));
            buffer.append("\"");
        }
        if (window.xulWindow.getSortDirection() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortDirection", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getSortDirection())));
            buffer.append("\"");
        }
        if (window.xulWindow.getSortResource() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getSortResource())));
            buffer.append("\"");
        }
        if (window.xulWindow.getSortResource2() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sortResource2", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getSortResource2())));
            buffer.append("\"");
        }
        if (window.xulWindow.getStatustext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "statustext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getStatustext())));
            buffer.append("\"");
        }
        if (window.xulWindow.getStyle() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "style", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getStyle())));
            buffer.append("\"");
        }
        if (window.xulWindow.getTemplate() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "template", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getTemplate())));
            buffer.append("\"");
        }
        if (window.xulWindow.getTooltip() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltip", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getTooltip())));
            buffer.append("\"");
        }
        if (window.xulWindow.getTooltiptext() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "tooltiptext", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getTooltiptext())));
            buffer.append("\"");
        }
        if (window.xulWindow.getTop() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "top", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getTop()));
            buffer.append("\"");
        }
        if (window.xulWindow.getUri() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "uri", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getUri())));
            buffer.append("\"");
        }
        if (window.xulWindow.getWidth() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "width", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getWidth()));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnclick() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onclick", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnclick())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnmousedown() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmousedown", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnmousedown())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnmouseup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnmouseup())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnmouseover() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseover", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnmouseover())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnmousemove() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmousemove", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnmousemove())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnmouseout() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onmouseout", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnmouseout())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOncommand() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "oncommand", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOncommand())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnkeypress() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeypress", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnkeypress())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnkeydown() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeydown", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnkeydown())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnkeyup() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onkeyup", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnkeyup())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnfocus() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onfocus", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnfocus())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnblur() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onblur", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnblur())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnload() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onload", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnload())));
            buffer.append("\"");
        }
        if (window.xulWindow.getOnunload() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "onunload", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getOnunload())));
            buffer.append("\"");
        }
        if (window.xulWindow.getHidechrome() != false) {
            buffer.append(" ");
            rNSContext_.makeQName("", "hidechrome", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getHidechrome()));
            buffer.append("\"");
        }
        if (window.xulWindow.getScreenX() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "screenX", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getScreenX()));
            buffer.append("\"");
        }
        if (window.xulWindow.getScreenY() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "screenY", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.getString(window.xulWindow.getScreenY()));
            buffer.append("\"");
        }
        if (window.xulWindow.getSizemode() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "sizemode", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getSizemode())));
            buffer.append("\"");
        }
        if (window.xulWindow.getTitle() != null) {
            mixed = window.xulWindow.getTitle();
            resolvedString = CoveElResolver.getResolver().resolveExpression(mixed);
            buffer.append(" ");
            rNSContext_.makeQName("", "title", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(resolvedString)));
            buffer.append("\"");
        }
        if (window.xulWindow.getWindowtype() != null) {
            buffer.append(" ");
            rNSContext_.makeQName("", "windowtype", buffer);
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(window.xulWindow.getWindowtype())));
            buffer.append("\"");
        }
        int size = window.xulWindow.getBlockClass().length;
        for (int i = 0;i < size;i++) {
            IXulWindowChoice value = window.xulWindow.getBlockClass()[i];
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }

    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
        WindowComponent window = (WindowComponent) component;
        char[] encoded = getEncodedEndString(window);
        ResponseWriter writer = context.getResponseWriter();
        writer.writeText(encoded, 0, encoded.length);
    }

    private char[] getEncodedEndString(WindowComponent window) {
        StringBuffer buffer = new StringBuffer();
        RNSContext rNSContext_ = window.xulWindow.rGetRNSContext();
        String prefix =
            rNSContext_.getPrefixByUri(
                "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
        buffer.append("</");
        URelaxer.makeQName(prefix, "window", buffer);
        buffer.append(">");
        return (new String(buffer)).toCharArray();
    }
}
