package com.netpotlet.xul.renderkit;

import java.io.OutputStream;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

import javax.faces.context.ResponseStream;
import javax.faces.context.ResponseWriter;
import javax.faces.render.RenderKit;
import javax.faces.render.Renderer;
import javax.faces.render.ResponseStateManager;

public class XulRenderKit extends RenderKit {
    private Map renderers;

    public XulRenderKit() {
        super();
        renderers = new HashMap();
    }

    public void addRenderer(
        String family,
        String renderType,
        Renderer renderer) {
        renderers.put(getKey(family, renderType), renderer);
    }

    public Renderer getRenderer(String family, String renderType) {
        Renderer renderer =
            (Renderer) renderers.get(getKey(family, renderType));
        if (renderer != null) {
            return renderer;
        }
        return null;
    }

    public ResponseStateManager getResponseStateManager() {
        return null;
    }

    public ResponseWriter createResponseWriter(
        Writer writer,
        String contentTypeList,
        String characterEncoding) {
        if (contentTypeList != null) {
            StringTokenizer st = new StringTokenizer(contentTypeList);
            while (st.hasMoreTokens()) {
                String contentType = st.nextToken().trim();
                return new CoveResponseWriter(
                    writer,
                    contentType,
                    characterEncoding);
            }
        }
        return null;
    }

    public ResponseStream createResponseStream(OutputStream arg0) {
        return null;
    }

    private String getKey(String family, String renderType) {
        return family + "/" + renderType;
    }
}
